/*
 * JanelaAutenticacao.java
 *
 * Created on 8 de Novembro de 2007, 10:44
 */
package requirementsmanager.gui;

import requirementsmanager.RequirementsManager;
import requirementsmanager.model.Gestor;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Utilizador;
import requirementsmanager.utils.Ligacao;

/**
 *
 * @author  ei10608
 */
public class JanelaAutenticacao extends javax.swing.JFrame {

    private String username;
    private String password;
    private Sistema sistema;
    private Utilizador utilizador;
    private JanelaAutenticacao me = this;

    /** Creates new form JanelaAutenticacao */
    public JanelaAutenticacao() {
        initComponents();

        if (!Ligacao.ligar(RequirementsManager.getConfigOption("DRIVERNAME"), 
                "jdbc:" + RequirementsManager.getConfigOption("URLBASE") + "://" + 
                RequirementsManager.getConfigOption("HOST") + "/" + 
                RequirementsManager.getConfigOption("DBNAME"),  
                RequirementsManager.getConfigOption("DBUSER"),
                RequirementsManager.getConfigOption("DBUSERPASS"))) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_ERROBASEDADOS"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_ERROLIGACAO"));
            sair();
        }
    }

    private void sair() {
        System.exit(0);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtUtilizador = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        btnSair = new javax.swing.JButton();
        btnEntrar = new javax.swing.JButton();
        txtPass = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("JANELAAUTENTICACAO_TITULO")); // NOI18N
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Autenticação"));

        jLabel1.setText(bundle.getString("JANELAAUTENTICACAO_USERNAME")); // NOI18N

        txtUtilizador.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtUtilizadorActionPerformed(evt);
            }
        });

        jLabel2.setText(bundle.getString("JANELAAUTENTICACAO_PASSWORD")); // NOI18N

        btnSair.setText(bundle.getString("JANELAAUTENTICACAO_BTNSAIR")); // NOI18N
        btnSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSairActionPerformed(evt);
            }
        });

        btnEntrar.setText(bundle.getString("JANELAAUTENTICACAO_BTNENTRAR")); // NOI18N
        btnEntrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEntrarActionPerformed(evt);
            }
        });

        txtPass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtPassActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addGap(12, 12, 12)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(btnEntrar, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSair, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(txtPass, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addComponent(txtUtilizador, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtUtilizador, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtPass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnEntrar)
                    .addComponent(btnSair)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-311)/2, (screenSize.height-161)/2, 311, 161);
    }// </editor-fold>//GEN-END:initComponents
    private void btnSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSairActionPerformed
        sair();
}//GEN-LAST:event_btnSairActionPerformed

    private void btnEntrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEntrarActionPerformed
        if (validar()) {
            if(sistema == null) {
                sistema = new Sistema();
            }
            
            username = txtUtilizador.getText();
            password = String.valueOf(txtPass.getPassword());
            
            if ((utilizador = sistema.autenticar(username, password)) != null) {
                switch (utilizador.getTipo()) {
                    case Utilizador.GESTOR:
                        dispose();
                        txtPass.setText("");
                        txtUtilizador.setText("");
                        java.awt.EventQueue.invokeLater(new Runnable() {
                            public void run() {
                                new JanelaGestao(sistema, (Gestor)utilizador, me).setVisible(true);
                            }
                        });
                        break;
                    case Utilizador.ADMINISTRADOR:
                        dispose();
                        txtPass.setText("");
                        txtUtilizador.setText("");
                        java.awt.EventQueue.invokeLater(new Runnable() {
                            public void run() {
                                new JanelaAdministracao(sistema, me).setVisible(true);
                            }
                        });
                        break;
                    default:
                        JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_INCONSISTENCIADADOS"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Da_base_de_dados"));
                }
            } else {
                JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_USEROUPASSINVALIDOS"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_TITULOERRO"));
            }
        }
    }//GEN-LAST:event_btnEntrarActionPerformed

    private void txtUtilizadorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtUtilizadorActionPerformed
        btnEntrar.doClick();
    }//GEN-LAST:event_txtUtilizadorActionPerformed

    private void txtPassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtPassActionPerformed
        btnEntrar.doClick();
    }//GEN-LAST:event_txtPassActionPerformed

    private boolean validar() {
        if (txtUtilizador.getText().isEmpty()) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_USEROBRIGATORIO"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Erro_de_validação"));
            return false;
        }

        if (txtPass.getPassword().length == 0) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("JANELAAUTENTICACAO_PASSOBRIGATORIA"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Erro_de_validação"));
            return false;
        }
        return true;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnEntrar;
    private javax.swing.JButton btnSair;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPasswordField txtPass;
    private javax.swing.JTextField txtUtilizador;
    // End of variables declaration//GEN-END:variables
}
