/*
 * JanelaDadosPessoais.java
 *
 * Created on 12 de Janeiro de 2008, 17:26
 */
package requirementsmanager.gui;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.GregorianCalendar;
import java.util.regex.Pattern;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import requirementsmanager.model.Gravavel;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Utilizador;
import requirementsmanager.model.listeners.GravavelListener;

/**
 *
 * @author  Knitter
 */
public class JanelaDadosPessoais extends javax.swing.JDialog implements GravavelListener {

    private Utilizador utilizador;
    private Sistema sistema;
    private Pattern pattern = Pattern.compile(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("[\\w._%+-]+@[\\w.-]+\\.[\\w]{2,3}"));
    private boolean emailInvalido;
    private boolean msnInvalido;
    private boolean icqInvalido;
    private boolean byUser = false;

    /** Creates new form JanelaDadosPessoais */
    public JanelaDadosPessoais(java.awt.Frame parent, Sistema sistema, Utilizador utilizador) {
        super(parent, true);
        this.utilizador = utilizador;
        System.err.println(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("3:_") + utilizador.getUsername());
        this.sistema = sistema;
        System.err.println(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("7:_") + utilizador.getUsername());
        
        initComponents();
        System.err.println(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("4:_") + utilizador.getUsername());
        jdcDataNascimento.getDateEditor().addPropertyChangeListener(new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent evt) {
                if (evt.getPropertyName().equals(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("date"))) {
                    valueChanged();
                }
            }
        });
        utilizador.addListener(this);
        System.err.println(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("5:_") + utilizador.getUsername());
        preencherCampos();
        byUser = true;
    }

    private boolean validarEmail(String email) {
        return pattern.matcher(email).matches();
    }

    private void mudarSexo() {
        if (jrbSexoFeminino.isSelected()) {
            utilizador.setSexo(Utilizador.SEXO_FEMININO);
        } else {
            utilizador.setSexo(Utilizador.SEXO_MASCULINO);
        }
    }

    private void valueChanged() {
        if(byUser) {
        if (jdcDataNascimento.getDate() != null) {
            if (utilizador.getDataNascimento() == null) {
                GregorianCalendar g = new GregorianCalendar();
                g.setTime(jdcDataNascimento.getDate());
                utilizador.setDataNascimento(g);
            } else {
                utilizador.getDataNascimento().setTime(jdcDataNascimento.getDate());
            }
        } else {
            utilizador.setDataNascimento(null);
        }

        utilizador.setEndereco(jtaEndereco.getText().trim());
        utilizador.setCodigoPostal(sistema.getCodigoPostal(jffCodigoPostal.getText().trim(), jtfLocalidade.getText().trim()));
        utilizador.setCodigoExtra(jffCodigoExtra.getText().trim());
        utilizador.setPassword(String.valueOf(jpfPassword.getPassword()));
        utilizador.setEmail(jtfEmail.getText().trim());
        utilizador.setIcq(jtfICQ.getText().trim());
        utilizador.setMsn(jtfMSN.getText().trim());
        utilizador.setNome(jtfNome.getText().trim());
        utilizador.setTelefone(jffTelefone.getText().trim());
        utilizador.setTelemovel(jffTelemovel.getText().trim());
        utilizador.setUsername(jtfUsername.getText().trim());
        }
    }

    private void preencherCampos() {
        if (utilizador != null) {
            byUser = false;
            if (utilizador.getDataNascimento() != null) {
                jdcDataNascimento.setDate(utilizador.getDataNascimento().getTime());
            } else {
                jdcDataNascimento.setDate(null);
            }

            if (utilizador.getSexo().equals(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("M"))) {
                jrbSexoMasculino.setSelected(true);
            } else {
                jrbSexoFeminino.setSelected(true);
            }

            if (utilizador.getCodigoPostal() != null) {
                jtfLocalidade.setText(utilizador.getCodigoPostal().getLocalidade());
                jffCodigoPostal.setText(utilizador.getCodigoPostal().getCodigo());
            } else {
                jtfLocalidade.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString(""));
                jffCodigoPostal.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString(""));
            }

            jffCodigoExtra.setText(utilizador.getCodigoExtra());
            jtaEndereco.setText(utilizador.getEndereco());
            jpfPassword.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("dummy"));
            jtfEmail.setText(utilizador.getEmail());
            jtfICQ.setText(utilizador.getIcq());
            jtfMSN.setText(utilizador.getMsn());
            jtfNome.setText(utilizador.getNome());
            jffTelefone.setText(utilizador.getTelemovel());
            jffTelemovel.setText(utilizador.getTelemovel());
            jtfUsername.setText(utilizador.getUsername());
            System.err.println(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("6:") + utilizador.getUsername());
            byUser = true;
        }
    }
    
    public void dataChanged(Gravavel g) {
        jbtnGravar.setEnabled(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jbgSexo = new javax.swing.ButtonGroup();
        jbgTipoUtilizador = new javax.swing.ButtonGroup();
        jPanel3 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jtfUsername = new javax.swing.JTextField();
        jtfUsername.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jLabel13 = new javax.swing.JLabel();
        jpfPassword = new javax.swing.JPasswordField();
        jpfPassword.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jtfNome.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jrbSexoMasculino = new javax.swing.JRadioButton();
        jrbSexoFeminino = new javax.swing.JRadioButton();
        jdcDataNascimento = new com.toedter.calendar.JDateChooser();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jtfLocalidade = new javax.swing.JTextField();
        jtfLocalidade.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jScrollPane1 = new javax.swing.JScrollPane();
        jtaEndereco = new javax.swing.JTextArea();
        jtaEndereco.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jtfEmail = new javax.swing.JTextField();
        jtfEmail.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jtfMSN = new javax.swing.JTextField();
        jtfICQ = new javax.swing.JTextField();
        jtfICQ.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffCodigoPostal = new javax.swing.JFormattedTextField();
        jffCodigoPostal.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffTelefone = new javax.swing.JFormattedTextField();
        jffTelefone.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffTelemovel = new javax.swing.JFormattedTextField();
        jffTelemovel.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffCodigoExtra = new javax.swing.JFormattedTextField();
        jffCodigoExtra.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jbtnFechar = new javax.swing.JButton();
        jbtnGravar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("Dados_Pessoais")); // NOI18N
        setResizable(false);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(" Dados de Autenticação"));

        jLabel12.setText(bundle.getString("Nome_de_Utilizador:")); // NOI18N

        jLabel13.setText(bundle.getString("Palavra-passe:")); // NOI18N

        jpfPassword.setText(bundle.getString("dummy")); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jpfPassword, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE)
                    .addComponent(jtfUsername, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE))
                .addGap(128, 128, 128))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jtfUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel13)
                    .addComponent(jpfPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(" Dados Pessoais "));

        jLabel1.setText(bundle.getString("Nome:")); // NOI18N

        jLabel2.setText(bundle.getString("Data_de_Nascimento:")); // NOI18N

        jLabel3.setText(bundle.getString("Sexo:")); // NOI18N

        jbgSexo.add(jrbSexoMasculino);
        jrbSexoMasculino.setText(bundle.getString("M")); // NOI18N
        jrbSexoMasculino.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jrbSexoMasculinoMouseClicked(evt);
            }
        });

        jbgSexo.add(jrbSexoFeminino);
        jrbSexoFeminino.setText(bundle.getString("F")); // NOI18N
        jrbSexoFeminino.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jrbSexoFemininoMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jdcDataNascimento, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(201, 201, 201))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jrbSexoMasculino)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jrbSexoFeminino))
                    .addComponent(jtfNome, javax.swing.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jLabel2))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jdcDataNascimento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(2, 2, 2)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jrbSexoMasculino)
                            .addComponent(jrbSexoFeminino)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3)))
                .addGap(34, 34, 34))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(" Contactos "));

        jLabel4.setText("Endereço:");

        jLabel5.setText(bundle.getString("Localidade:")); // NOI18N

        jLabel6.setText("Código Postal:");

        jLabel7.setText(bundle.getString("Telefone:")); // NOI18N

        jLabel8.setText("Telemóvel:");

        jLabel9.setText(bundle.getString("E-mail:")); // NOI18N

        jLabel10.setText(bundle.getString("MSN:")); // NOI18N

        jLabel11.setText(bundle.getString("ICQ:")); // NOI18N

        jtaEndereco.setColumns(20);
        jtaEndereco.setRows(5);
        jScrollPane1.setViewportView(jtaEndereco);

        jtfEmail.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jtfEmailFocusLost(evt);
            }
        });

        jtfMSN.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jtfMSN.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jtfMSNFocusLost(evt);
            }
        });

        jtfICQ.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jtfICQFocusLost(evt);
            }
        });

        try {
            jffCodigoPostal.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("####")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }

        try {
            jffTelefone.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("############")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }

        try {
            jffTelemovel.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("############")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }

        try {
            jffCodigoExtra.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("###")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8)
                    .addComponent(jLabel9)
                    .addComponent(jLabel10)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 321, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jffTelefone, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(jtfLocalidade, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(jtfMSN, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(jtfICQ, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(jtfEmail, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                                .addComponent(jffCodigoPostal, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jffCodigoExtra, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jffTelemovel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE))
                        .addGap(114, 114, 114)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jtfLocalidade, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(jffCodigoPostal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jffCodigoExtra, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7)
                    .addComponent(jffTelefone, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jffTelemovel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jtfEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtfMSN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(jtfICQ, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        jbtnGravar.setText(bundle.getString("Guardar")); // NOI18N
        jbtnGravar.setEnabled(false);
        jbtnGravar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnGravarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnGravar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnFechar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbtnFechar)
                    .addComponent(jbtnGravar))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-458)/2, (screenSize.height-619)/2, 458, 619);
    }// </editor-fold>//GEN-END:initComponents
    private void jbtnGravarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnGravarActionPerformed
        if (emailInvalido) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("email_inváliod"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Titulo"));
        } else if (msnInvalido) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("msn_invalido"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Titulo"));
        } else if (icqInvalido) {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("icq_invalido"), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("titulo"));
        } else {
            sistema.gravar();
            jbtnGravar.setEnabled(false);
        }
}//GEN-LAST:event_jbtnGravarActionPerformed

    private void jrbSexoMasculinoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbSexoMasculinoMouseClicked
        mudarSexo();
    }//GEN-LAST:event_jrbSexoMasculinoMouseClicked

    private void jrbSexoFemininoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbSexoFemininoMouseClicked
        mudarSexo();
    }//GEN-LAST:event_jrbSexoFemininoMouseClicked

    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        dispose();
    }//GEN-LAST:event_jbtnFecharActionPerformed

    private void jtfEmailFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jtfEmailFocusLost
        if(!validarEmail(jtfEmail.getText().trim())) {
            emailInvalido = true;
        }
    }//GEN-LAST:event_jtfEmailFocusLost

    private void jtfMSNFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jtfMSNFocusLost
        if(!validarEmail(jtfMSN.getText().trim())) {
            msnInvalido = true;
        }
    }//GEN-LAST:event_jtfMSNFocusLost

    private void jtfICQFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jtfICQFocusLost
        if(!validarEmail(jtfICQ.getText().trim())) {
          icqInvalido = true;
        }
    }//GEN-LAST:event_jtfICQFocusLost

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.ButtonGroup jbgSexo;
    private javax.swing.ButtonGroup jbgTipoUtilizador;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JButton jbtnGravar;
    private com.toedter.calendar.JDateChooser jdcDataNascimento;
    private javax.swing.JFormattedTextField jffCodigoExtra;
    private javax.swing.JFormattedTextField jffCodigoPostal;
    private javax.swing.JFormattedTextField jffTelefone;
    private javax.swing.JFormattedTextField jffTelemovel;
    private javax.swing.JPasswordField jpfPassword;
    private javax.swing.JRadioButton jrbSexoFeminino;
    private javax.swing.JRadioButton jrbSexoMasculino;
    private javax.swing.JTextArea jtaEndereco;
    private javax.swing.JTextField jtfEmail;
    private javax.swing.JTextField jtfICQ;
    private javax.swing.JTextField jtfLocalidade;
    private javax.swing.JTextField jtfMSN;
    private javax.swing.JTextField jtfNome;
    private javax.swing.JTextField jtfUsername;
    // End of variables declaration//GEN-END:variables
    
    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }
}
