/*
 * JanelaDadosUtilizadores.java
 *
 * Created on 12 de Janeiro de 2008, 17:13
 */
package requirementsmanager.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.GregorianCalendar;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import requirementsmanager.model.Gravavel;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Utilizador;
import requirementsmanager.model.listeners.GravavelListener;

/**
 *
 * @author  Knitter
 */
public class JanelaDadosUtilizadores extends javax.swing.JDialog implements GravavelListener {

    private Sistema sistema;
    private Utilizador utilizador;
    private boolean editavel = false;
    private boolean byUser = true;

    /** Creates new form JanelaDadosUtilizadores */
    public JanelaDadosUtilizadores(java.awt.Frame parent, Sistema sistema) {
        super(parent, true);
        this.sistema = sistema;
        utilizador = sistema.getUtilizadorAutenticado();
        utilizador.addListener(this);
        initComponents();
        jdcDataNascimento.getDateEditor().addPropertyChangeListener(new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent evt) {
                if (evt.getPropertyName().equals(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("date"))) {
                    valueChanged();
                }
            }
        });
        System.err.println(utilizador.getUsername());
        centrar();
    }
    
    private void centrar() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
    }
    
    private void mudarSexo() {
        if (jrbSexoFeminino.isSelected()) {
            ((Utilizador) jlstListaUtilizadores.getSelectedValue()).setSexo(Utilizador.SEXO_FEMININO);
        } else {
            ((Utilizador) jlstListaUtilizadores.getSelectedValue()).setSexo(Utilizador.SEXO_MASCULINO);
        }
    }    

    private void valueChanged() {
        if (byUser) {
            Utilizador temp = (Utilizador) jlstListaUtilizadores.getSelectedValue();

            if (jdcDataNascimento.getDate() != null) {
                if (temp.getDataNascimento() == null) {
                    GregorianCalendar g = new GregorianCalendar();
                    g.setTime(jdcDataNascimento.getDate());
                    temp.setDataNascimento(g);
                } else {
                    temp.getDataNascimento().setTime(jdcDataNascimento.getDate());
                }
            } else {
                temp.setDataNascimento(null);
            }

            temp.setEndereco(jtaEndereco.getText().trim());
            temp.setCodigoPostal(sistema.getCodigoPostal(jffCodPostal.getText().trim(), jtfLocalidade.getText().trim()));
            temp.setCodigoExtra(jffCodExtra.getText().trim());
            temp.setPassword(String.valueOf(jpfPassword.getPassword()));
            temp.setEmail(jtfEmail.getText().trim());
            temp.setIcq(jtfICQ.getText().trim());
            temp.setMsn(jtfMSN.getText().trim());
            temp.setNome(jtfNome.getText().trim());
            temp.setTelefone(jffTelefone.getText().trim());
            temp.setTelemovel(jffTelemovel.getText().trim());
            temp.setUsername(jtfUsername.getText().trim());
        }
    }

    private void activarEdicao() {
        jdcDataNascimento.setEnabled(true);
        jffCodExtra.setEditable(true);
        jffCodPostal.setEditable(true);
        jpfPassword.setEditable(true);
        jrbSexoFeminino.setEnabled(true);
        jrbSexoMasculino.setEnabled(true);
        jtaEndereco.setEditable(true);
        jtfEmail.setEditable(true);
        jtfICQ.setEditable(true);
        jtfLocalidade.setEditable(true);
        jtfMSN.setEditable(true);
        jtfNome.setEditable(true);
        jffTelefone.setEditable(true);
        jffTelemovel.setEditable(true);
        jtfUsername.setEditable(true);
        editavel = true;
    }

    private void desactivarEdicao() {
        jdcDataNascimento.setEnabled(false);
        jffCodExtra.setEditable(false);
        jffCodPostal.setEditable(false);
        jpfPassword.setEditable(false);
        jrbSexoFeminino.setEnabled(false);
        jrbSexoMasculino.setEnabled(false);
        jtaEndereco.setEditable(false);
        jtfEmail.setEditable(false);
        jtfICQ.setEditable(false);
        jtfLocalidade.setEditable(false);
        jtfMSN.setEditable(false);
        jtfNome.setEditable(false);
        jffTelefone.setEditable(false);
        jffTelemovel.setEditable(false);
        jtfUsername.setEditable(false);
        editavel = false;
    }

    public void dataChanged(Gravavel g) {
        jbtnGuardar.setEnabled(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpListaUtilizadores = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jlstListaUtilizadores = new javax.swing.JList(sistema.getUtilizadores().toArray());
        jpDadosAutenticacao = new javax.swing.JPanel();
        jlblUsername = new javax.swing.JLabel();
        jtfUsername = new javax.swing.JTextField();
        jtfUsername.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jlblPassword = new javax.swing.JLabel();
        jpfPassword = new javax.swing.JPasswordField();
        jpfPassword.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jpDadosPessoais = new javax.swing.JPanel();
        jlblNome = new javax.swing.JLabel();
        jlblDataNascimento = new javax.swing.JLabel();
        jlblSexo = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jtfNome.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jrbSexoMasculino = new javax.swing.JRadioButton();
        jrbSexoFeminino = new javax.swing.JRadioButton();
        jdcDataNascimento = new com.toedter.calendar.JDateChooser();
        jpContactos = new javax.swing.JPanel();
        jlblEndereco = new javax.swing.JLabel();
        jlblLocalidade = new javax.swing.JLabel();
        jlblCodPostal = new javax.swing.JLabel();
        jlblTelefone = new javax.swing.JLabel();
        jlblTelemovel = new javax.swing.JLabel();
        jlblEmail = new javax.swing.JLabel();
        jlblMSN = new javax.swing.JLabel();
        jlblICQ = new javax.swing.JLabel();
        jtfLocalidade = new javax.swing.JTextField();
        jtfLocalidade.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jScrollPane1 = new javax.swing.JScrollPane();
        jtaEndereco = new javax.swing.JTextArea();
        jtaEndereco.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffCodPostal = new javax.swing.JFormattedTextField();
        jffCodPostal.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffCodExtra = new javax.swing.JFormattedTextField();
        jffCodExtra.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jffTelefone = new javax.swing.JFormattedTextField();
        jffTelemovel = new javax.swing.JFormattedTextField();
        jtfEmail = new javax.swing.JTextField();
        jtfMSN = new javax.swing.JTextField();
        jtfICQ = new javax.swing.JTextField();
        jtfICQ.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jbtnFechar = new javax.swing.JButton();
        jbtnGuardar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("Lista_de_Utilizadores_existentes")); // NOI18N
        setResizable(false);

        jpListaUtilizadores.setBorder(javax.swing.BorderFactory.createTitledBorder("Lista de Utilizadores"));

        jlstListaUtilizadores.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstListaUtilizadores.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstListaUtilizadoresValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jlstListaUtilizadores);

        javax.swing.GroupLayout jpListaUtilizadoresLayout = new javax.swing.GroupLayout(jpListaUtilizadores);
        jpListaUtilizadores.setLayout(jpListaUtilizadoresLayout);
        jpListaUtilizadoresLayout.setHorizontalGroup(
            jpListaUtilizadoresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpListaUtilizadoresLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE)
                .addContainerGap())
        );
        jpListaUtilizadoresLayout.setVerticalGroup(
            jpListaUtilizadoresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpListaUtilizadoresLayout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 472, Short.MAX_VALUE)
                .addContainerGap())
        );

        jpDadosAutenticacao.setBorder(javax.swing.BorderFactory.createTitledBorder(" Dados de Autenticação"));

        jlblUsername.setText(bundle.getString("Nome_de_Utilizador:")); // NOI18N

        jtfUsername.setEditable(false);

        jlblPassword.setText(bundle.getString("Palavra-passe:")); // NOI18N

        jpfPassword.setEditable(false);

        javax.swing.GroupLayout jpDadosAutenticacaoLayout = new javax.swing.GroupLayout(jpDadosAutenticacao);
        jpDadosAutenticacao.setLayout(jpDadosAutenticacaoLayout);
        jpDadosAutenticacaoLayout.setHorizontalGroup(
            jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDadosAutenticacaoLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblUsername)
                    .addComponent(jlblPassword))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jpfPassword)
                    .addComponent(jtfUsername, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE))
                .addContainerGap(74, Short.MAX_VALUE))
        );
        jpDadosAutenticacaoLayout.setVerticalGroup(
            jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDadosAutenticacaoLayout.createSequentialGroup()
                .addGroup(jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblUsername)
                    .addComponent(jtfUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addGroup(jpDadosAutenticacaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblPassword)
                    .addComponent(jpfPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpDadosPessoais.setBorder(javax.swing.BorderFactory.createTitledBorder(" Dados Pessoais "));

        jlblNome.setText(bundle.getString("Nome:")); // NOI18N

        jlblDataNascimento.setText(bundle.getString("Data_de_Nascimento:")); // NOI18N

        jlblSexo.setText(bundle.getString("Sexo:")); // NOI18N

        jtfNome.setEditable(false);

        jrbSexoMasculino.setText(bundle.getString("M")); // NOI18N
        jrbSexoMasculino.setEnabled(false);
        jrbSexoMasculino.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jrbSexoMasculinoMouseClicked(evt);
            }
        });

        jrbSexoFeminino.setText(bundle.getString("F")); // NOI18N
        jrbSexoFeminino.setEnabled(false);
        jrbSexoFeminino.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jrbSexoFemininoMouseClicked(evt);
            }
        });

        jdcDataNascimento.setEnabled(false);

        javax.swing.GroupLayout jpDadosPessoaisLayout = new javax.swing.GroupLayout(jpDadosPessoais);
        jpDadosPessoais.setLayout(jpDadosPessoaisLayout);
        jpDadosPessoaisLayout.setHorizontalGroup(
            jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblNome)
                    .addComponent(jlblDataNascimento)
                    .addComponent(jlblSexo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jdcDataNascimento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                        .addComponent(jrbSexoMasculino)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jrbSexoFeminino))
                    .addComponent(jtfNome, javax.swing.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE))
                .addContainerGap())
        );
        jpDadosPessoaisLayout.setVerticalGroup(
            jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblNome)
                    .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jlblDataNascimento))
                    .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jdcDataNascimento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                        .addGap(2, 2, 2)
                        .addGroup(jpDadosPessoaisLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jrbSexoMasculino)
                            .addComponent(jrbSexoFeminino)))
                    .addGroup(jpDadosPessoaisLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jlblSexo)))
                .addGap(34, 34, 34))
        );

        jpContactos.setBorder(javax.swing.BorderFactory.createTitledBorder(" Contactos "));

        jlblEndereco.setText("Endereço:");

        jlblLocalidade.setText(bundle.getString("Localidade:")); // NOI18N

        jlblCodPostal.setText("Código Postal:");

        jlblTelefone.setText(bundle.getString("Telefone:")); // NOI18N

        jlblTelemovel.setText("Telemóvel:");

        jlblEmail.setText(bundle.getString("E-mail:")); // NOI18N

        jlblMSN.setText(bundle.getString("MSN:")); // NOI18N

        jlblICQ.setText(bundle.getString("ICQ:")); // NOI18N

        jtfLocalidade.setEditable(false);

        jtaEndereco.setColumns(20);
        jtaEndereco.setEditable(false);
        jtaEndereco.setRows(5);
        jScrollPane1.setViewportView(jtaEndereco);

        jffCodPostal.setEditable(false);

        jffCodExtra.setEditable(false);

        jffTelefone.setEditable(false);
        jffTelefone.getDocument().addDocumentListener(new AlteracaoDocumentoListener());

        jffTelemovel.setEditable(false);
        jffTelemovel.getDocument().addDocumentListener(new AlteracaoDocumentoListener());

        jtfEmail.setEditable(false);
        jtfEmail.getDocument().addDocumentListener(new AlteracaoDocumentoListener());

        jtfMSN.setEditable(false);
        jtfMSN.getDocument().addDocumentListener(new AlteracaoDocumentoListener());

        jtfICQ.setEditable(false);

        javax.swing.GroupLayout jpContactosLayout = new javax.swing.GroupLayout(jpContactos);
        jpContactos.setLayout(jpContactosLayout);
        jpContactosLayout.setHorizontalGroup(
            jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpContactosLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblEndereco)
                    .addComponent(jlblLocalidade)
                    .addComponent(jlblCodPostal)
                    .addComponent(jlblTelefone)
                    .addComponent(jlblTelemovel)
                    .addComponent(jlblEmail)
                    .addComponent(jlblMSN)
                    .addComponent(jlblICQ))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 267, Short.MAX_VALUE)
                    .addGroup(jpContactosLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jtfLocalidade, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpContactosLayout.createSequentialGroup()
                                .addComponent(jffCodPostal, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jffCodExtra, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jffTelefone, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jffTelemovel, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jtfEmail, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jtfMSN, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jtfICQ, javax.swing.GroupLayout.Alignment.LEADING))))
                .addContainerGap())
        );
        jpContactosLayout.setVerticalGroup(
            jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpContactosLayout.createSequentialGroup()
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblEndereco)
                    .addGroup(jpContactosLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jtfLocalidade, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jlblLocalidade))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jlblCodPostal)
                            .addComponent(jffCodPostal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jffCodExtra, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblTelefone)
                    .addComponent(jffTelefone, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblTelemovel)
                    .addComponent(jffTelemovel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblEmail)
                    .addComponent(jtfEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblMSN)
                    .addComponent(jtfMSN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpContactosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jlblICQ)
                    .addComponent(jtfICQ, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(17, Short.MAX_VALUE))
        );

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        jbtnGuardar.setText(bundle.getString("Guardar")); // NOI18N
        jbtnGuardar.setEnabled(false);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpListaUtilizadores, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jpContactos, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jpDadosAutenticacao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGap(10, 10, 10))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jpDadosPessoais, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jbtnGuardar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnFechar)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpDadosAutenticacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpDadosPessoais, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jpContactos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jpListaUtilizadores, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbtnFechar)
                    .addComponent(jbtnGuardar))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jlstListaUtilizadoresValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstListaUtilizadoresValueChanged
        int index = jlstListaUtilizadores.getSelectedIndex();
        if (index > 0) {
            byUser = false;
            Utilizador actual = (Utilizador) jlstListaUtilizadores.getSelectedValue();
            if (actual.getId() == utilizador.getId()) {
                activarEdicao();
            } else {
                if (editavel) {
                    desactivarEdicao();
                }
            }

            if (actual.getDataNascimento() != null) {
                jdcDataNascimento.setDate(actual.getDataNascimento().getTime());
            } else {
                jdcDataNascimento.setDate(null);
            }

            if (actual.getSexo().equals(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("M"))) {
                jrbSexoMasculino.setSelected(true);
            } else {
                jrbSexoFeminino.setSelected(true);
            }

            if (actual.getCodigoPostal() != null) {
                jtfLocalidade.setText(actual.getCodigoPostal().getLocalidade());
                jffCodPostal.setText(actual.getCodigoPostal().getCodigo());
            } else {
                jtfLocalidade.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString(""));
                jffCodPostal.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString(""));
            }

            jffCodExtra.setText(actual.getCodigoExtra());
            jtaEndereco.setText(actual.getEndereco());
            jpfPassword.setText(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("dummy"));
            jtfEmail.setText(actual.getEmail());
            jtfICQ.setText(actual.getIcq());
            jtfMSN.setText(actual.getMsn());
            jtfNome.setText(actual.getNome());
            jffTelefone.setText(actual.getTelemovel());
            jffTelemovel.setText(actual.getTelemovel());
            jtfUsername.setText(actual.getUsername());
            byUser = true;
        }
        
    }//GEN-LAST:event_jlstListaUtilizadoresValueChanged

    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        dispose();
    }//GEN-LAST:event_jbtnFecharActionPerformed

    private void jrbSexoMasculinoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbSexoMasculinoMouseClicked
        mudarSexo();
    }//GEN-LAST:event_jrbSexoMasculinoMouseClicked

    private void jrbSexoFemininoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbSexoFemininoMouseClicked
        mudarSexo();
    }//GEN-LAST:event_jrbSexoFemininoMouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JButton jbtnGuardar;
    private com.toedter.calendar.JDateChooser jdcDataNascimento;
    private javax.swing.JFormattedTextField jffCodExtra;
    private javax.swing.JFormattedTextField jffCodPostal;
    private javax.swing.JFormattedTextField jffTelefone;
    private javax.swing.JFormattedTextField jffTelemovel;
    private javax.swing.JLabel jlblCodPostal;
    private javax.swing.JLabel jlblDataNascimento;
    private javax.swing.JLabel jlblEmail;
    private javax.swing.JLabel jlblEndereco;
    private javax.swing.JLabel jlblICQ;
    private javax.swing.JLabel jlblLocalidade;
    private javax.swing.JLabel jlblMSN;
    private javax.swing.JLabel jlblNome;
    private javax.swing.JLabel jlblPassword;
    private javax.swing.JLabel jlblSexo;
    private javax.swing.JLabel jlblTelefone;
    private javax.swing.JLabel jlblTelemovel;
    private javax.swing.JLabel jlblUsername;
    private javax.swing.JList jlstListaUtilizadores;
    private javax.swing.JPanel jpContactos;
    private javax.swing.JPanel jpDadosAutenticacao;
    private javax.swing.JPanel jpDadosPessoais;
    private javax.swing.JPanel jpListaUtilizadores;
    private javax.swing.JPasswordField jpfPassword;
    private javax.swing.JRadioButton jrbSexoFeminino;
    private javax.swing.JRadioButton jrbSexoMasculino;
    private javax.swing.JTextArea jtaEndereco;
    private javax.swing.JTextField jtfEmail;
    private javax.swing.JTextField jtfICQ;
    private javax.swing.JTextField jtfLocalidade;
    private javax.swing.JTextField jtfMSN;
    private javax.swing.JTextField jtfNome;
    private javax.swing.JTextField jtfUsername;
    // End of variables declaration//GEN-END:variables
    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }
}
