/*
 * JanelaGestaoTiposTeste.java
 *
 * Created on 12 de Janeiro de 2008, 0:48
 */
package requirementsmanager.gui;

import java.util.LinkedList;
import javax.swing.DefaultListModel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import requirementsmanager.model.Gravavel;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.TipoTeste;
import requirementsmanager.model.listeners.GravavelListener;

/**
 *
 * @author  Knitter
 */
public class JanelaGestaoTiposTeste extends javax.swing.JDialog implements GravavelListener {

    private Sistema sistema;
    private int selectedIndex;
    private DefaultListModel model;
    private boolean byUser = false;
    private int numTipos = 0;

    /** Creates new form JanelaGestaoTiposTeste */
    public JanelaGestaoTiposTeste(java.awt.Frame parent, Sistema sistema) {
        super(parent, true);
        this.sistema = sistema;
        initModel();
        initComponents();
        jlstListaTestes.setSelectedIndex(0);
        byUser = true;
    }

    private void initModel() {
        model = new DefaultListModel();
        LinkedList<TipoTeste> tipos = sistema.getTiposTeste();

        for (TipoTeste t : tipos) {
            model.addElement(t);
        }

    /*model.addListDataListener(new ListDataListener() {
    public void intervalAdded(ListDataEvent e) {
    //do nothing
    }
    public void intervalRemoved(ListDataEvent e) {
    if(model.getSize() == 0) {
    byUser = false;
    jtfNome.setText("");
    jtaDescricao.setText("");
    byUser = true;
    jbtnApagar.setEnabled(false);
    }
    }
    public void contentsChanged(ListDataEvent e) {
    //do nothing
    }
    });*/
    }

    private void valueChanged() {
        if (byUser) {
            TipoTeste teste = (TipoTeste) model.get(jlstListaTestes.getSelectedIndex());
            teste.setNome(jtfNome.getText().trim());
            teste.setDescricao(jtaDescricao.getText().trim());
        }
    }

    private void adicionarTipoTeste() {
        int fakeId = sistema.getTiposTeste().size() + 1;
        TipoTeste novo = new TipoTeste(fakeId, java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Novo_Tipo_") + (++numTipos), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString(""), true, false);
        novo.addListener(this);
        model.addElement(novo);
        jlstListaTestes.setSelectedIndex((selectedIndex = model.getSize() - 1));
        sistema.adicionarTipoTeste(novo);
        jbtnAplicar.setEnabled(true);
    }

    private void gravar() {
        sistema.gravar();
        jbtnAplicar.setEnabled(false);
    }

    private void apagarTipoTeste() {
        boolean deleted = false;
        int oldSelection = selectedIndex;
        
        if (sistema.podeRemover((TipoTeste) model.get(selectedIndex))) {
            sistema.removerTipoTeste((TipoTeste) model.get(selectedIndex));
            model.remove(selectedIndex);
            jbtnAplicar.setEnabled(true);
            deleted = true;
        } else {
            JanelaErro.mostrarErro(java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Existem_testes_criados_com_o_tipo_seleccionado."), java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Impossível_remover"));
            deleted = false;
        }
        if (deleted) {
            if (oldSelection > 0) {
                jlstListaTestes.setSelectedIndex(oldSelection - 1);
            } else {
                jlstListaTestes.clearSelection();
            }
        }
    }

    public void dataChanged(Gravavel g) {
        jbtnAplicar.setEnabled(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpGestaoTestes = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jlstListaTestes = new javax.swing.JList();
        jlstListaTestes.setModel(model);
        jpDetalhes = new javax.swing.JPanel();
        jlblNome = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jtfNome.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jlblDescricao = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtaDescricao = new javax.swing.JTextArea();
        jtaDescricao.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jtbnNovoTeste = new javax.swing.JButton();
        jbtnApagar = new javax.swing.JButton();
        jbtnFechar = new javax.swing.JButton();
        jbtnAplicar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("Tipos_de_Teste")); // NOI18N
        setResizable(false);

        jpGestaoTestes.setBorder(javax.swing.BorderFactory.createTitledBorder(" Gestão de Testes "));

        jlstListaTestes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstListaTestes.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstListaTestesValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jlstListaTestes);

        jpDetalhes.setBorder(javax.swing.BorderFactory.createTitledBorder(" Detalhes "));

        jlblNome.setText(bundle.getString("Nome:")); // NOI18N

        jlblDescricao.setText("Descrição:");

        jtaDescricao.setColumns(20);
        jtaDescricao.setRows(5);
        jScrollPane2.setViewportView(jtaDescricao);

        javax.swing.GroupLayout jpDetalhesLayout = new javax.swing.GroupLayout(jpDetalhes);
        jpDetalhes.setLayout(jpDetalhesLayout);
        jpDetalhesLayout.setHorizontalGroup(
            jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDetalhesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblDescricao)
                    .addComponent(jlblNome))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jtfNome, javax.swing.GroupLayout.DEFAULT_SIZE, 284, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 284, Short.MAX_VALUE))
                .addContainerGap())
        );
        jpDetalhesLayout.setVerticalGroup(
            jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpDetalhesLayout.createSequentialGroup()
                .addGroup(jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlblNome)
                    .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpDetalhesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlblDescricao))
                .addContainerGap(22, Short.MAX_VALUE))
        );

        jtbnNovoTeste.setText(bundle.getString("Novo")); // NOI18N
        jtbnNovoTeste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jtbnNovoTesteActionPerformed(evt);
            }
        });

        jbtnApagar.setText(bundle.getString("Apagar")); // NOI18N
        jbtnApagar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnApagarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpGestaoTestesLayout = new javax.swing.GroupLayout(jpGestaoTestes);
        jpGestaoTestes.setLayout(jpGestaoTestesLayout);
        jpGestaoTestesLayout.setHorizontalGroup(
            jpGestaoTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpGestaoTestesLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jpDetalhes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(jpGestaoTestesLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jtbnNovoTeste)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnApagar)
                .addContainerGap(421, Short.MAX_VALUE))
        );
        jpGestaoTestesLayout.setVerticalGroup(
            jpGestaoTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpGestaoTestesLayout.createSequentialGroup()
                .addGroup(jpGestaoTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)
                    .addComponent(jpDetalhes, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpGestaoTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtbnNovoTeste)
                    .addComponent(jbtnApagar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        jbtnAplicar.setText(bundle.getString("Aplicar")); // NOI18N
        jbtnAplicar.setEnabled(false);
        jbtnAplicar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAplicarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jpGestaoTestes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jbtnAplicar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnFechar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jpGestaoTestes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbtnFechar)
                    .addComponent(jbtnAplicar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-605)/2, (screenSize.height-415)/2, 605, 415);
    }// </editor-fold>//GEN-END:initComponents
    private void jlstListaTestesValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstListaTestesValueChanged
        selectedIndex = jlstListaTestes.getSelectedIndex();
        TipoTeste actual;
        if (selectedIndex >= 0) {
            byUser = false;
            actual = (TipoTeste) model.get(selectedIndex);
            jtfNome.setText(actual.getNome());
            jtaDescricao.setText(actual.getDescricao());
            byUser = true;
        }
    }//GEN-LAST:event_jlstListaTestesValueChanged

    private void jtbnNovoTesteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jtbnNovoTesteActionPerformed
        adicionarTipoTeste();
    }//GEN-LAST:event_jtbnNovoTesteActionPerformed

    private void jbtnApagarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnApagarActionPerformed
        apagarTipoTeste();
    }//GEN-LAST:event_jbtnApagarActionPerformed

    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        dispose();
    }//GEN-LAST:event_jbtnFecharActionPerformed

    private void jbtnAplicarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAplicarActionPerformed
        gravar();
    }//GEN-LAST:event_jbtnAplicarActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton jbtnApagar;
    private javax.swing.JButton jbtnAplicar;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JLabel jlblDescricao;
    private javax.swing.JLabel jlblNome;
    private javax.swing.JList jlstListaTestes;
    private javax.swing.JPanel jpDetalhes;
    private javax.swing.JPanel jpGestaoTestes;
    private javax.swing.JTextArea jtaDescricao;
    private javax.swing.JButton jtbnNovoTeste;
    private javax.swing.JTextField jtfNome;
    // End of variables declaration//GEN-END:variables
    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }
}
