/*
 * ListarCUSemR.java
 *
 * Created on 15 de Novembro de 2007, 10:08
 */
package requirementsmanager.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.DefaultListModel;
import javax.swing.JTextField;
import requirementsmanager.model.CasoUso;
import requirementsmanager.model.PontoExtensao;
import requirementsmanager.model.Projecto;
import requirementsmanager.model.Requisito;
import requirementsmanager.model.Sistema;

/**
 *
 */
public class JanelaListarCUSemR extends javax.swing.JDialog {

    private DefaultListModel modelCasosUsoSR;
    private DefaultListModel modelReqAss;
    private DefaultListModel modelReqExis;
    private Projecto projecto;
    private Sistema sistema;
    private boolean hasChanged = false;

    /** Creates new form ListarCUSemR */
    public JanelaListarCUSemR(java.awt.Frame parent, Sistema sistema, Projecto projecto) {
        super(parent, true);
        this.projecto = projecto;
        this.sistema = sistema;

        preencherModelo();
        initComponents();
        jlstCasosUso.setSelectedIndex(0);
        centrar();
    }
    
    private void centrar() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
    }
    
    private void preencherModelo() {
        modelCasosUsoSR = new DefaultListModel();
        for (CasoUso cU : projecto.getListaCasosUsoValidos()) {
            if (cU.getRequisitos().isEmpty()) {
                modelCasosUsoSR.addElement(cU);
            }
        }

        modelReqAss = new DefaultListModel();
        modelReqExis = new DefaultListModel();
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpCasosUso = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jlstCasosUso = new javax.swing.JList();
        jbtnFechar = new javax.swing.JButton();
        jpRequisitos = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jlstRequisitosExistentes = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jbtnRemoverAssociacao = new javax.swing.JButton();
        jbtnAdicionarAssociacao = new javax.swing.JButton();
        jbtnRemoverTodasAssociacoes = new javax.swing.JButton();
        jbtnAdicionarTodasAssociacoes = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jlstRequisitosAssociados = new javax.swing.JList();
        jpCaracteristicasCasoUso = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtaDescricao = new javax.swing.JTextArea();
        jtfIdentificador = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jcbxPontosExtensao = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("Casos_de_Uso_sem_Requisitos")); // NOI18N
        setResizable(false);

        jpCasosUso.setBorder(javax.swing.BorderFactory.createTitledBorder(" Casos de uso sem requisitos "));

        jlstCasosUso.setModel(modelCasosUsoSR);
        jlstCasosUso.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstCasosUso.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstCasosUsoValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jlstCasosUso);

        javax.swing.GroupLayout jpCasosUsoLayout = new javax.swing.GroupLayout(jpCasosUso);
        jpCasosUso.setLayout(jpCasosUsoLayout);
        jpCasosUsoLayout.setHorizontalGroup(
            jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCasosUsoLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                .addContainerGap())
        );
        jpCasosUsoLayout.setVerticalGroup(
            jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCasosUsoLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                .addContainerGap())
        );

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        jpRequisitos.setBorder(javax.swing.BorderFactory.createTitledBorder(" Requisitos "));

        jlstRequisitosExistentes.setModel(modelReqExis);
        jlstRequisitosExistentes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane3.setViewportView(jlstRequisitosExistentes);

        jLabel6.setText(bundle.getString("Existentes")); // NOI18N

        jLabel7.setText(bundle.getString("Associados")); // NOI18N

        jbtnRemoverAssociacao.setText(bundle.getString("<")); // NOI18N
        jbtnRemoverAssociacao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverAssociacaoActionPerformed(evt);
            }
        });

        jbtnAdicionarAssociacao.setText(bundle.getString(">")); // NOI18N
        jbtnAdicionarAssociacao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarAssociacaoActionPerformed(evt);
            }
        });

        jbtnRemoverTodasAssociacoes.setText(bundle.getString("<<")); // NOI18N
        jbtnRemoverTodasAssociacoes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverTodasAssociacoesActionPerformed(evt);
            }
        });

        jbtnAdicionarTodasAssociacoes.setText(bundle.getString(">>")); // NOI18N
        jbtnAdicionarTodasAssociacoes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarTodasAssociacoesActionPerformed(evt);
            }
        });

        jlstRequisitosAssociados.setModel(modelReqAss);
        jlstRequisitosAssociados.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane4.setViewportView(jlstRequisitosAssociados);

        javax.swing.GroupLayout jpRequisitosLayout = new javax.swing.GroupLayout(jpRequisitos);
        jpRequisitos.setLayout(jpRequisitosLayout);
        jpRequisitosLayout.setHorizontalGroup(
            jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpRequisitosLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpRequisitosLayout.createSequentialGroup()
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jbtnAdicionarTodasAssociacoes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnAdicionarAssociacao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverAssociacao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverTodasAssociacoes)))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addContainerGap())
        );
        jpRequisitosLayout.setVerticalGroup(
            jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpRequisitosLayout.createSequentialGroup()
                .addGroup(jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane4, 0, 0, Short.MAX_VALUE)
                    .addGroup(jpRequisitosLayout.createSequentialGroup()
                        .addComponent(jbtnRemoverTodasAssociacoes)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnRemoverAssociacao)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnAdicionarAssociacao)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnAdicionarTodasAssociacoes)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpCaracteristicasCasoUso.setBorder(javax.swing.BorderFactory.createTitledBorder(" Características do Caso de Uso "));

        jLabel1.setText(bundle.getString("Identificador:")); // NOI18N

        jLabel2.setText("Descrição:");

        jtaDescricao.setColumns(20);
        jtaDescricao.setEditable(false);
        jtaDescricao.setRows(5);
        jScrollPane2.setViewportView(jtaDescricao);

        jtfIdentificador.setEditable(false);

        jLabel3.setText("Pontos de Extensão:");

        javax.swing.GroupLayout jpCaracteristicasCasoUsoLayout = new javax.swing.GroupLayout(jpCaracteristicasCasoUso);
        jpCaracteristicasCasoUso.setLayout(jpCaracteristicasCasoUsoLayout);
        jpCaracteristicasCasoUsoLayout.setHorizontalGroup(
            jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCaracteristicasCasoUsoLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 387, Short.MAX_VALUE)
                    .addGroup(jpCaracteristicasCasoUsoLayout.createSequentialGroup()
                        .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jtfIdentificador, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE)))
                    .addGroup(jpCaracteristicasCasoUsoLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jcbxPontosExtensao, 0, 283, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jpCaracteristicasCasoUsoLayout.setVerticalGroup(
            jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCaracteristicasCasoUsoLayout.createSequentialGroup()
                .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jtfIdentificador, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasCasoUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jcbxPontosExtensao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpCasosUso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jpRequisitos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jpCaracteristicasCasoUso, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addComponent(jbtnFechar, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jpCasosUso, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jpCaracteristicasCasoUso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpRequisitos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnFechar)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        if (hasChanged) {
            ((JanelaGestao) getOwner()).editado();
        }
        dispose();
}//GEN-LAST:event_jbtnFecharActionPerformed

    private void jlstCasosUsoValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstCasosUsoValueChanged
        CasoUso caso = (CasoUso) jlstCasosUso.getSelectedValue();
        if (caso != null) {
            jtfIdentificador.setText(caso.getIdentificador());
            jtaDescricao.setText(caso.getDescricao());
            jcbxPontosExtensao.removeAllItems();
            for (PontoExtensao p : caso.getPontosExtensaoValidos()) {
                jcbxPontosExtensao.addItem(p);
            }

            modelReqAss.clear();
            modelReqExis.clear();

            for (Requisito r : caso.getProjecto().getListaRequisitosValidos()) {
                if (caso.getRequisitos().contains(r)) {
                    modelReqAss.addElement(r);
                } else {
                    modelReqExis.addElement(r);
                }
            }
        }
}//GEN-LAST:event_jlstCasosUsoValueChanged

    private void jbtnRemoverTodasAssociacoesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverTodasAssociacoesActionPerformed
        if (sistema.desassociarTodos((CasoUso) jlstCasosUso.getSelectedValue())) {
            for (int i = 0; i < modelReqAss.size(); i++) {
                modelReqExis.addElement(modelReqAss.get(i));
            }
            modelReqAss.clear();
            hasChanged = true;
        }
}//GEN-LAST:event_jbtnRemoverTodasAssociacoesActionPerformed

    private void jbtnRemoverAssociacaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverAssociacaoActionPerformed
        Requisito r;
        if ((r = (Requisito) jlstRequisitosAssociados.getSelectedValue()) != null) {
            if (sistema.desassociar((CasoUso) jlstCasosUso.getSelectedValue(), r)) {
                modelReqExis.addElement(r);
                modelReqAss.removeElement(r);
                hasChanged = true;
            }
        }
}//GEN-LAST:event_jbtnRemoverAssociacaoActionPerformed

    private void jbtnAdicionarAssociacaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarAssociacaoActionPerformed
        Requisito r;
        if ((r = (Requisito) jlstRequisitosExistentes.getSelectedValue()) != null) {
            if (sistema.associar((CasoUso) jlstCasosUso.getSelectedValue(), r)) {
                modelReqAss.addElement(r);
                modelReqExis.removeElement(r);
                hasChanged = true;
            }
        } 
}//GEN-LAST:event_jbtnAdicionarAssociacaoActionPerformed

    private void jbtnAdicionarTodasAssociacoesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarTodasAssociacoesActionPerformed
        if (sistema.associarTodos((CasoUso) jlstCasosUso.getSelectedValue())) {
            for (int i = 0; i < modelReqExis.size(); i++) {
                modelReqAss.addElement(modelReqExis.get(i));
            }
            modelReqExis.clear();
            hasChanged = true;
        }           
}//GEN-LAST:event_jbtnAdicionarTodasAssociacoesActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton jbtnAdicionarAssociacao;
    private javax.swing.JButton jbtnAdicionarTodasAssociacoes;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JButton jbtnRemoverAssociacao;
    private javax.swing.JButton jbtnRemoverTodasAssociacoes;
    private javax.swing.JComboBox jcbxPontosExtensao;
    private javax.swing.JList jlstCasosUso;
    private javax.swing.JList jlstRequisitosAssociados;
    private javax.swing.JList jlstRequisitosExistentes;
    private javax.swing.JPanel jpCaracteristicasCasoUso;
    private javax.swing.JPanel jpCasosUso;
    private javax.swing.JPanel jpRequisitos;
    private javax.swing.JTextArea jtaDescricao;
    private javax.swing.JTextField jtfIdentificador;
    // End of variables declaration//GEN-END:variables
}
