/*
 * JanelaListarProjectos.java
 *
 * Created on 14 de Janeiro de 2008, 21:39
 */
package requirementsmanager.gui;

import java.util.LinkedList;
import javax.swing.DefaultListModel;
import requirementsmanager.model.Gestor;
import requirementsmanager.model.Projecto;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Utilizador;

/**
 *
 * @author  Knitter
 */
public class JanelaListarProjectos extends javax.swing.JDialog {

    private DefaultListModel modelProjectos;
    private DefaultListModel modelGestoresExistentes;
    private DefaultListModel modelGestoresAssociados;
    private Sistema sistema;
    private boolean hasBeenChanged = false;

    /** Creates new form JanelaListarProjectos */
    public JanelaListarProjectos(java.awt.Frame parent, Sistema sistema) {
        super(parent, true);
        this.sistema = sistema;
        initModels();
        initComponents();
        jlstProjectos.setSelectedIndex(0);
    }

    private void initModels() {
        modelProjectos = new DefaultListModel();
        for (Projecto p : sistema.getProjectos(true)) {
            modelProjectos.addElement(p);
        }

        modelGestoresExistentes = new DefaultListModel();
        modelGestoresAssociados = new DefaultListModel();
    }

    private void filtrarProjectos() {
        modelProjectos.clear();
        if (jckbFiltroOrfaos.isSelected()) {
            for (Projecto p : sistema.getProjectosOrfaos()) {
                modelProjectos.addElement(p);
            }
        } else {
            for (Projecto p : sistema.getProjectos(false)) {
                modelProjectos.addElement(p);
            }
        }
        jlstProjectos.setSelectedIndex(0);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpProjectos = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jlstProjectos = new javax.swing.JList();
        jpCaracteristicas = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtaDescricao = new javax.swing.JTextArea();
        jLabel2 = new javax.swing.JLabel();
        jpMembros = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jlstMembrosExistentes = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jbtnRemoverAssociado = new javax.swing.JButton();
        jbtnAdicionarAssociado = new javax.swing.JButton();
        jbtnRemoverTodosAssociados = new javax.swing.JButton();
        jbtnAdicionarTodosAssociados = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jlstMembrosAssociados = new javax.swing.JList();
        jpFiltro = new javax.swing.JPanel();
        jckbFiltroOrfaos = new javax.swing.JCheckBox();
        jbtnFechar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jpProjectos.setBorder(javax.swing.BorderFactory.createTitledBorder("Lista de Projectos"));

        jlstProjectos.setModel(modelProjectos);
        jlstProjectos.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstProjectos.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstProjectosValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jlstProjectos);

        javax.swing.GroupLayout jpProjectosLayout = new javax.swing.GroupLayout(jpProjectos);
        jpProjectos.setLayout(jpProjectosLayout);
        jpProjectosLayout.setHorizontalGroup(
            jpProjectosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpProjectosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 164, Short.MAX_VALUE)
                .addContainerGap())
        );
        jpProjectosLayout.setVerticalGroup(
            jpProjectosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpProjectosLayout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 272, Short.MAX_VALUE)
                .addContainerGap())
        );

        jpCaracteristicas.setBorder(javax.swing.BorderFactory.createTitledBorder(" Características do Projecto "));

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        jLabel1.setText(bundle.getString("Nome:")); // NOI18N

        jtfNome.setEditable(false);

        jtaDescricao.setColumns(20);
        jtaDescricao.setEditable(false);
        jtaDescricao.setRows(5);
        jScrollPane1.setViewportView(jtaDescricao);

        jLabel2.setText("Descrição:");

        javax.swing.GroupLayout jpCaracteristicasLayout = new javax.swing.GroupLayout(jpCaracteristicas);
        jpCaracteristicas.setLayout(jpCaracteristicasLayout);
        jpCaracteristicasLayout.setHorizontalGroup(
            jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCaracteristicasLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jtfNome, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE))
                .addContainerGap())
        );
        jpCaracteristicasLayout.setVerticalGroup(
            jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCaracteristicasLayout.createSequentialGroup()
                .addGroup(jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 135, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpMembros.setBorder(javax.swing.BorderFactory.createTitledBorder(" Membros "));

        jlstMembrosExistentes.setModel(modelGestoresExistentes);
        jlstMembrosExistentes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane3.setViewportView(jlstMembrosExistentes);

        jLabel6.setText(bundle.getString("Existentes")); // NOI18N

        jLabel7.setText(bundle.getString("Associados")); // NOI18N

        jbtnRemoverAssociado.setText(bundle.getString("<")); // NOI18N
        jbtnRemoverAssociado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverAssociadoActionPerformed(evt);
            }
        });

        jbtnAdicionarAssociado.setText(bundle.getString(">")); // NOI18N
        jbtnAdicionarAssociado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarAssociadoActionPerformed(evt);
            }
        });

        jbtnRemoverTodosAssociados.setText(bundle.getString("<<")); // NOI18N
        jbtnRemoverTodosAssociados.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverTodosAssociadosActionPerformed(evt);
            }
        });

        jbtnAdicionarTodosAssociados.setText(bundle.getString(">>")); // NOI18N
        jbtnAdicionarTodosAssociados.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarTodosAssociadosActionPerformed(evt);
            }
        });

        jlstMembrosAssociados.setModel(modelGestoresAssociados);
        jlstMembrosAssociados.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane4.setViewportView(jlstMembrosAssociados);

        javax.swing.GroupLayout jpMembrosLayout = new javax.swing.GroupLayout(jpMembros);
        jpMembros.setLayout(jpMembrosLayout);
        jpMembrosLayout.setHorizontalGroup(
            jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpMembrosLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpMembrosLayout.createSequentialGroup()
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jbtnAdicionarTodosAssociados, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnAdicionarAssociado, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverAssociado, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverTodosAssociados)))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addContainerGap())
        );
        jpMembrosLayout.setVerticalGroup(
            jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpMembrosLayout.createSequentialGroup()
                .addGroup(jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpMembrosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane4, 0, 0, Short.MAX_VALUE)
                    .addGroup(jpMembrosLayout.createSequentialGroup()
                        .addComponent(jbtnRemoverTodosAssociados)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnRemoverAssociado)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnAdicionarAssociado)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnAdicionarTodosAssociados)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpFiltro.setBorder(javax.swing.BorderFactory.createTitledBorder(" Filtros "));

        jckbFiltroOrfaos.setText("Projectos Orfãos");
        jckbFiltroOrfaos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jckbFiltroOrfaosActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpFiltroLayout = new javax.swing.GroupLayout(jpFiltro);
        jpFiltro.setLayout(jpFiltroLayout);
        jpFiltroLayout.setHorizontalGroup(
            jpFiltroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpFiltroLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jckbFiltroOrfaos)
                .addContainerGap(71, Short.MAX_VALUE))
        );
        jpFiltroLayout.setVerticalGroup(
            jpFiltroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpFiltroLayout.createSequentialGroup()
                .addComponent(jckbFiltroOrfaos)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jpFiltro, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jpProjectos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jpCaracteristicas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jpMembros, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jbtnFechar, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpCaracteristicas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpMembros, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpProjectos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpFiltro, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnFechar)
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-657)/2, (screenSize.height-464)/2, 657, 464);
    }// </editor-fold>//GEN-END:initComponents
    private void jlstProjectosValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstProjectosValueChanged
        int index = jlstProjectos.getSelectedIndex();
        if (index > 0) {
            Projecto projecto = (Projecto) modelProjectos.get(index);
            LinkedList<Gestor> lista = projecto.getListaGestores();

            jtfNome.setText(projecto.getNome());
            jtaDescricao.setText(projecto.getDescricao());

            modelGestoresAssociados.clear();
            modelGestoresExistentes.clear();

            for (Utilizador u : sistema.getUtilizadores()) {
                if (lista.contains(u)) {
                    modelGestoresAssociados.addElement(u);
                } else if (u.getTipo() == Utilizador.GESTOR) {
                    modelGestoresExistentes.addElement(u);
                }
            }
        }
}//GEN-LAST:event_jlstProjectosValueChanged

    private void jbtnRemoverAssociadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverAssociadoActionPerformed
        Gestor g = null;
        Projecto projecto = (Projecto) jlstProjectos.getSelectedValue();
        if ((g = (Gestor) jlstMembrosAssociados.getSelectedValue()) != null) {
            if (sistema.desassociar(g, projecto)) {
                modelGestoresExistentes.addElement(g);
                modelGestoresAssociados.removeElement(g);
            }
        } 
}//GEN-LAST:event_jbtnRemoverAssociadoActionPerformed

    private void jbtnAdicionarAssociadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarAssociadoActionPerformed
        Gestor g = null;
        Projecto projecto = (Projecto) jlstProjectos.getSelectedValue();
        if ((g = (Gestor) jlstMembrosExistentes.getSelectedValue()) != null) {
            if (sistema.associar(g, projecto)) {
                modelGestoresAssociados.addElement(g);
                modelGestoresExistentes.removeElement(g);
            }
        }
}//GEN-LAST:event_jbtnAdicionarAssociadoActionPerformed

    private void jbtnRemoverTodosAssociadosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverTodosAssociadosActionPerformed
        Projecto projecto = (Projecto) jlstProjectos.getSelectedValue();
        if (sistema.desassociarTodos(projecto)) {
            for (int i = 0; i < modelGestoresAssociados.size(); i++) {
                modelGestoresExistentes.addElement(modelGestoresAssociados.get(i));
            }
            modelGestoresAssociados.clear();
        }
}//GEN-LAST:event_jbtnRemoverTodosAssociadosActionPerformed

    private void jbtnAdicionarTodosAssociadosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarTodosAssociadosActionPerformed
        Projecto projecto = (Projecto) jlstProjectos.getSelectedValue();
        if (sistema.associarTodos(projecto)) {
            for (int i = 0; i < modelGestoresExistentes.size(); i++) {
                modelGestoresAssociados.addElement(modelGestoresExistentes.get(i));
            }
            modelGestoresExistentes.clear();
        }
}//GEN-LAST:event_jbtnAdicionarTodosAssociadosActionPerformed

    private void jckbFiltroOrfaosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jckbFiltroOrfaosActionPerformed
        filtrarProjectos();
}//GEN-LAST:event_jckbFiltroOrfaosActionPerformed

    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        modelProjectos.clear();
        if(hasBeenChanged) {
            ((JanelaGestao)getOwner()).editado();
        }
        dispose();
    }//GEN-LAST:event_jbtnFecharActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JButton jbtnAdicionarAssociado;
    private javax.swing.JButton jbtnAdicionarTodosAssociados;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JButton jbtnRemoverAssociado;
    private javax.swing.JButton jbtnRemoverTodosAssociados;
    private javax.swing.JCheckBox jckbFiltroOrfaos;
    private javax.swing.JList jlstMembrosAssociados;
    private javax.swing.JList jlstMembrosExistentes;
    private javax.swing.JList jlstProjectos;
    private javax.swing.JPanel jpCaracteristicas;
    private javax.swing.JPanel jpFiltro;
    private javax.swing.JPanel jpMembros;
    private javax.swing.JPanel jpProjectos;
    private javax.swing.JTextArea jtaDescricao;
    private javax.swing.JTextField jtfNome;
    // End of variables declaration//GEN-END:variables
}
