/*
 * ListarCUSemR.java
 *
 * Created on 15 de Novembro de 2007, 10:08
 */
package requirementsmanager.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.DefaultListModel;
import requirementsmanager.model.CasoUso;
import requirementsmanager.model.Projecto;
import requirementsmanager.model.Requisito;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Teste;

/**
 *
 * @author  ei10608
 */
public class JanelaListarRSemCU extends javax.swing.JDialog {

    private Sistema sistema;
    private Projecto projecto;
    private DefaultListModel modelRequisitos;
    private DefaultListModel modelCasosExistentes;
    private DefaultListModel modelCasosAssociados;
    private DefaultListModel modelTestesExistentes;
    private DefaultListModel modelTestesAssociados;
    private boolean hasChanged = false;

    /** Creates new form ListarCUSemR */
    public JanelaListarRSemCU(java.awt.Frame parent, Sistema sistema, Projecto projecto) {
        super(parent, true);
        this.sistema = sistema;
        this.projecto = projecto;
        initModel();
        initComponents();
        centrar();
    }

    private void centrar() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
    }

    private void initModel() {
        modelRequisitos = new DefaultListModel();
        for (Requisito r : projecto.getListaRequisitosValidos()) {
            if (r.getCasosUso().isEmpty()) {
                modelRequisitos.addElement(r);
            }

        }

        modelRequisitos = new DefaultListModel();
        modelCasosExistentes =
                new DefaultListModel();
        modelCasosAssociados =
                new DefaultListModel();
        modelTestesExistentes =
                new DefaultListModel();
        modelTestesAssociados =
                new DefaultListModel();

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btgOrigem = new javax.swing.ButtonGroup();
        btgRisco = new javax.swing.ButtonGroup();
        btgPrioridade = new javax.swing.ButtonGroup();
        jbtnFechar = new javax.swing.JButton();
        jpRequisitos = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jlstRequisitos = new javax.swing.JList();
        jpCaracteristicasRequisito = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtaDescricao = new javax.swing.JTextArea();
        jtfIdentificador = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jrbOrigemEquipa = new javax.swing.JRadioButton();
        jrbOrigemCliente = new javax.swing.JRadioButton();
        jrbRiscoAlto = new javax.swing.JRadioButton();
        jrbRiscoBaixo = new javax.swing.JRadioButton();
        jrbPrioridadeAlta = new javax.swing.JRadioButton();
        jrbPrioridadeMedia = new javax.swing.JRadioButton();
        jrbPrioridadeBaixa = new javax.swing.JRadioButton();
        jpCasosUso = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jlstCasosExistentes = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jbtnRemoverAssociacaoCasoUso = new javax.swing.JButton();
        jbtnAdicionarAssociacaoCasoUso = new javax.swing.JButton();
        jbtnRemoverTodasAssociacoesCasoUso = new javax.swing.JButton();
        jbtnAdicionarTodasAssociacoesCasoUso = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jlstCasosAssociados = new javax.swing.JList();
        jpTestes = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jlstTestesExistentes = new javax.swing.JList();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jbtnRemoverAssociacaoTeste = new javax.swing.JButton();
        jbtnAdicionarAssociacaoTeste = new javax.swing.JButton();
        jbtnRemoverTodasAssociacoesTeste = new javax.swing.JButton();
        jbtnAdicionarTodasAssociacoesTeste = new javax.swing.JButton();
        jScrollPane6 = new javax.swing.JScrollPane();
        jlstTestesAssociados = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        setTitle(bundle.getString("Requisitos_sem_Caso_de_Uso")); // NOI18N
        setResizable(false);

        jbtnFechar.setText(bundle.getString("Fechar")); // NOI18N
        jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFecharActionPerformed(evt);
            }
        });

        jpRequisitos.setBorder(javax.swing.BorderFactory.createTitledBorder(" Requisitos sem casos de uso "));

        jlstRequisitos.setModel(modelRequisitos);
        jlstRequisitos.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jlstRequisitos.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jlstRequisitosValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jlstRequisitos);

        javax.swing.GroupLayout jpRequisitosLayout = new javax.swing.GroupLayout(jpRequisitos);
        jpRequisitos.setLayout(jpRequisitosLayout);
        jpRequisitosLayout.setHorizontalGroup(
            jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpRequisitosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                .addContainerGap())
        );
        jpRequisitosLayout.setVerticalGroup(
            jpRequisitosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpRequisitosLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 533, Short.MAX_VALUE)
                .addContainerGap())
        );

        jpCaracteristicasRequisito.setBorder(javax.swing.BorderFactory.createTitledBorder(" Características do Requisito "));

        jLabel1.setText(bundle.getString("Identificador:")); // NOI18N

        jLabel2.setText("Descrição:");

        jtaDescricao.setColumns(20);
        jtaDescricao.setEditable(false);
        jtaDescricao.setRows(5);
        jScrollPane2.setViewportView(jtaDescricao);

        jtfIdentificador.setEditable(false);

        jLabel3.setText(bundle.getString("Risco:")); // NOI18N

        jLabel4.setText(bundle.getString("Origem:")); // NOI18N

        jLabel5.setText(bundle.getString("Prioridade:")); // NOI18N

        btgOrigem.add(jrbOrigemEquipa);
        jrbOrigemEquipa.setText(bundle.getString("Equipa")); // NOI18N
        jrbOrigemEquipa.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbOrigemEquipa.setEnabled(false);
        jrbOrigemEquipa.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgOrigem.add(jrbOrigemCliente);
        jrbOrigemCliente.setText(bundle.getString("Cliente")); // NOI18N
        jrbOrigemCliente.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbOrigemCliente.setEnabled(false);
        jrbOrigemCliente.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgRisco.add(jrbRiscoAlto);
        jrbRiscoAlto.setText(bundle.getString("Alto")); // NOI18N
        jrbRiscoAlto.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbRiscoAlto.setEnabled(false);
        jrbRiscoAlto.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgRisco.add(jrbRiscoBaixo);
        jrbRiscoBaixo.setText(bundle.getString("Baixo")); // NOI18N
        jrbRiscoBaixo.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbRiscoBaixo.setEnabled(false);
        jrbRiscoBaixo.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgPrioridade.add(jrbPrioridadeAlta);
        jrbPrioridadeAlta.setText(bundle.getString("Alta")); // NOI18N
        jrbPrioridadeAlta.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbPrioridadeAlta.setEnabled(false);
        jrbPrioridadeAlta.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgPrioridade.add(jrbPrioridadeMedia);
        jrbPrioridadeMedia.setText("Média");
        jrbPrioridadeMedia.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbPrioridadeMedia.setEnabled(false);
        jrbPrioridadeMedia.setMargin(new java.awt.Insets(0, 0, 0, 0));

        btgPrioridade.add(jrbPrioridadeBaixa);
        jrbPrioridadeBaixa.setText(bundle.getString("Baixa")); // NOI18N
        jrbPrioridadeBaixa.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jrbPrioridadeBaixa.setEnabled(false);
        jrbPrioridadeBaixa.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout jpCaracteristicasRequisitoLayout = new javax.swing.GroupLayout(jpCaracteristicasRequisito);
        jpCaracteristicasRequisito.setLayout(jpCaracteristicasRequisitoLayout);
        jpCaracteristicasRequisitoLayout.setHorizontalGroup(
            jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpCaracteristicasRequisitoLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 397, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpCaracteristicasRequisitoLayout.createSequentialGroup()
                        .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jtfIdentificador, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpCaracteristicasRequisitoLayout.createSequentialGroup()
                        .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3)
                            .addComponent(jLabel5))
                        .addGap(17, 17, 17)
                        .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jrbOrigemEquipa)
                            .addComponent(jrbRiscoAlto)
                            .addComponent(jrbPrioridadeAlta))
                        .addGap(15, 15, 15)
                        .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpCaracteristicasRequisitoLayout.createSequentialGroup()
                                .addComponent(jrbPrioridadeMedia)
                                .addGap(23, 23, 23)
                                .addComponent(jrbPrioridadeBaixa))
                            .addComponent(jrbRiscoBaixo)
                            .addComponent(jrbOrigemCliente))
                        .addGap(101, 101, 101)))
                .addContainerGap())
        );
        jpCaracteristicasRequisitoLayout.setVerticalGroup(
            jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCaracteristicasRequisitoLayout.createSequentialGroup()
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jtfIdentificador, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jrbOrigemEquipa)
                    .addComponent(jLabel4)
                    .addComponent(jrbOrigemCliente))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jrbRiscoAlto)
                    .addComponent(jrbRiscoBaixo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCaracteristicasRequisitoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jrbPrioridadeAlta)
                    .addComponent(jrbPrioridadeMedia)
                    .addComponent(jrbPrioridadeBaixa))
                .addContainerGap(17, Short.MAX_VALUE))
        );

        jpCasosUso.setBorder(javax.swing.BorderFactory.createTitledBorder(" Casos de Uso "));

        jlstCasosExistentes.setModel(modelCasosExistentes);
        jlstCasosExistentes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane3.setViewportView(jlstCasosExistentes);

        jLabel6.setText(bundle.getString("Existentes")); // NOI18N

        jLabel7.setText(bundle.getString("Associados")); // NOI18N

        jbtnRemoverAssociacaoCasoUso.setText(bundle.getString("<")); // NOI18N
        jbtnRemoverAssociacaoCasoUso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverAssociacaoCasoUsoActionPerformed(evt);
            }
        });

        jbtnAdicionarAssociacaoCasoUso.setText(bundle.getString(">")); // NOI18N
        jbtnAdicionarAssociacaoCasoUso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarAssociacaoCasoUsoActionPerformed(evt);
            }
        });

        jbtnRemoverTodasAssociacoesCasoUso.setText(bundle.getString("<<")); // NOI18N
        jbtnRemoverTodasAssociacoesCasoUso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverTodasAssociacoesCasoUsoActionPerformed(evt);
            }
        });

        jbtnAdicionarTodasAssociacoesCasoUso.setText(bundle.getString(">>")); // NOI18N
        jbtnAdicionarTodasAssociacoesCasoUso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarTodasAssociacoesCasoUsoActionPerformed(evt);
            }
        });

        jlstCasosAssociados.setModel(modelCasosAssociados);
        jlstCasosAssociados.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane4.setViewportView(jlstCasosAssociados);

        javax.swing.GroupLayout jpCasosUsoLayout = new javax.swing.GroupLayout(jpCasosUso);
        jpCasosUso.setLayout(jpCasosUsoLayout);
        jpCasosUsoLayout.setHorizontalGroup(
            jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCasosUsoLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpCasosUsoLayout.createSequentialGroup()
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jbtnAdicionarTodasAssociacoesCasoUso, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnAdicionarAssociacaoCasoUso, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverAssociacaoCasoUso, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverTodasAssociacoesCasoUso)))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpCasosUsoLayout.createSequentialGroup()
                        .addComponent(jLabel7)
                        .addGap(130, 130, 130))
                    .addGroup(jpCasosUsoLayout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 173, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        jpCasosUsoLayout.setVerticalGroup(
            jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpCasosUsoLayout.createSequentialGroup()
                .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, 0, 0, Short.MAX_VALUE)
                    .addGroup(jpCasosUsoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE)
                        .addGroup(jpCasosUsoLayout.createSequentialGroup()
                            .addComponent(jbtnRemoverTodasAssociacoesCasoUso)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnRemoverAssociacaoCasoUso)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnAdicionarAssociacaoCasoUso)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnAdicionarTodasAssociacoesCasoUso))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpTestes.setBorder(javax.swing.BorderFactory.createTitledBorder(" Testes "));

        jlstTestesExistentes.setModel(modelTestesExistentes);
        jlstTestesExistentes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane5.setViewportView(jlstTestesExistentes);

        jLabel8.setText(bundle.getString("Existentes")); // NOI18N

        jLabel9.setText(bundle.getString("Associados")); // NOI18N

        jbtnRemoverAssociacaoTeste.setText(bundle.getString("<")); // NOI18N
        jbtnRemoverAssociacaoTeste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverAssociacaoTesteActionPerformed(evt);
            }
        });

        jbtnAdicionarAssociacaoTeste.setText(bundle.getString(">")); // NOI18N
        jbtnAdicionarAssociacaoTeste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarAssociacaoTesteActionPerformed(evt);
            }
        });

        jbtnRemoverTodasAssociacoesTeste.setText(bundle.getString("<<")); // NOI18N
        jbtnRemoverTodasAssociacoesTeste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnRemoverTodasAssociacoesTesteActionPerformed(evt);
            }
        });

        jbtnAdicionarTodasAssociacoesTeste.setText(bundle.getString(">>")); // NOI18N
        jbtnAdicionarTodasAssociacoesTeste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAdicionarTodasAssociacoesTesteActionPerformed(evt);
            }
        });

        jlstTestesAssociados.setModel(modelTestesAssociados);
        jlstTestesAssociados.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane6.setViewportView(jlstTestesAssociados);

        javax.swing.GroupLayout jpTestesLayout = new javax.swing.GroupLayout(jpTestes);
        jpTestes.setLayout(jpTestesLayout);
        jpTestesLayout.setHorizontalGroup(
            jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpTestesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpTestesLayout.createSequentialGroup()
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jbtnAdicionarTodasAssociacoesTeste, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnAdicionarAssociacaoTeste, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverAssociacaoTeste, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jbtnRemoverTodasAssociacoesTeste)))
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpTestesLayout.createSequentialGroup()
                        .addComponent(jLabel9)
                        .addGap(130, 130, 130))
                    .addGroup(jpTestesLayout.createSequentialGroup()
                        .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 173, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        jpTestesLayout.setVerticalGroup(
            jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpTestesLayout.createSequentialGroup()
                .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jLabel9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane6, 0, 0, Short.MAX_VALUE)
                    .addGroup(jpTestesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jScrollPane5, 0, 0, Short.MAX_VALUE)
                        .addGroup(jpTestesLayout.createSequentialGroup()
                            .addComponent(jbtnRemoverTodasAssociacoesTeste)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnRemoverAssociacaoTeste)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnAdicionarAssociacaoTeste)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jbtnAdicionarTodasAssociacoesTeste))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jpRequisitos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jpCaracteristicasRequisito, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jpCasosUso, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jpTestes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(578, Short.MAX_VALUE)
                .addComponent(jbtnFechar)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jpRequisitos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpCaracteristicasRequisito, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpCasosUso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jpTestes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnFechar)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jbtnFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFecharActionPerformed
        if (hasChanged) {
            ((JanelaGestao) getOwner()).editado();
        }

        dispose();
}//GEN-LAST:event_jbtnFecharActionPerformed

    private void jbtnRemoverTodasAssociacoesTesteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverTodasAssociacoesTesteActionPerformed
        if (sistema.desassociarTodosTestes((Requisito) jlstRequisitos.getSelectedValue())) {
            for (int i = 0; i <
                    modelTestesAssociados.size(); i++) {
                modelTestesExistentes.addElement(modelTestesAssociados.get(i));
            }

            modelTestesAssociados.clear();
        }
    }//GEN-LAST:event_jbtnRemoverTodasAssociacoesTesteActionPerformed

    private void jbtnRemoverAssociacaoTesteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverAssociacaoTesteActionPerformed
        Teste t;
        if ((t = (Teste) jlstTestesAssociados.getSelectedValue()) != null) {
            if (sistema.desassociar(t, (Requisito) jlstRequisitos.getSelectedValue())) {
                modelTestesExistentes.addElement(t);
                modelTestesAssociados.removeElement(t);
            }

        }
    }//GEN-LAST:event_jbtnRemoverAssociacaoTesteActionPerformed

    private void jbtnAdicionarAssociacaoTesteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarAssociacaoTesteActionPerformed
        Teste t;
        if ((t = (Teste) jlstTestesExistentes.getSelectedValue()) != null) {
            if (sistema.associar(t, (Requisito) jlstRequisitos.getSelectedValue())) {
                modelTestesAssociados.addElement(t);
                modelTestesExistentes.removeElement(t);
            }

        }
    }//GEN-LAST:event_jbtnAdicionarAssociacaoTesteActionPerformed

    private void jbtnAdicionarTodasAssociacoesTesteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarTodasAssociacoesTesteActionPerformed
        if (sistema.associarTodosTestes((Requisito) jlstRequisitos.getSelectedValue())) {
            for (int i = 0; i <
                    modelTestesExistentes.size(); i++) {
                modelTestesExistentes.addElement(modelTestesExistentes.get(i));
            }

            modelTestesExistentes.clear();
        }
    }//GEN-LAST:event_jbtnAdicionarTodasAssociacoesTesteActionPerformed

    private void jbtnRemoverTodasAssociacoesCasoUsoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverTodasAssociacoesCasoUsoActionPerformed
        if (sistema.desassociarTodosCasosUso((Requisito) jlstRequisitos.getSelectedValue())) {
            for (int i = 0; i <
                    modelCasosAssociados.size(); i++) {
                modelCasosExistentes.addElement(modelCasosAssociados.get(i));
            }

            modelCasosAssociados.clear();
        }
    }//GEN-LAST:event_jbtnRemoverTodasAssociacoesCasoUsoActionPerformed

    private void jbtnRemoverAssociacaoCasoUsoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnRemoverAssociacaoCasoUsoActionPerformed
        CasoUso c;
        if ((c = (CasoUso) jlstCasosAssociados.getSelectedValue()) != null) {
            if (sistema.desassociar(c, (Requisito) jlstRequisitos.getSelectedValue())) {
                modelCasosExistentes.addElement(c);
                modelCasosAssociados.removeElement(c);
            }

        }
    }//GEN-LAST:event_jbtnRemoverAssociacaoCasoUsoActionPerformed

    private void jbtnAdicionarAssociacaoCasoUsoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarAssociacaoCasoUsoActionPerformed
        CasoUso c;
        if ((c = (CasoUso) jlstCasosExistentes.getSelectedValue()) != null) {
            if (sistema.associar(c, (Requisito) jlstRequisitos.getSelectedValue())) {
                modelCasosAssociados.addElement(c);
                modelCasosExistentes.removeElement(c);
            }

        }
    }//GEN-LAST:event_jbtnAdicionarAssociacaoCasoUsoActionPerformed

    private void jbtnAdicionarTodasAssociacoesCasoUsoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAdicionarTodasAssociacoesCasoUsoActionPerformed
        if (sistema.associarTodosCasosUso((Requisito) jlstRequisitos.getSelectedValue())) {
            for (int i = 0; i <
                    modelCasosExistentes.size(); i++) {
                modelCasosAssociados.addElement(modelCasosExistentes.get(i));
            }

            modelCasosExistentes.clear();
        }
    }//GEN-LAST:event_jbtnAdicionarTodasAssociacoesCasoUsoActionPerformed

    private void jlstRequisitosValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jlstRequisitosValueChanged
        Requisito requisito = (Requisito) jlstRequisitos.getSelectedValue();
        if (requisito != null) {
            jtfIdentificador.setText(requisito.getIdentificador());
            jtaDescricao.setText(requisito.getDescricao());
            switch (requisito.getOrigem()) {
                case Requisito.ORIGEM_EQUIPA:
                    jrbOrigemEquipa.setSelected(true);
                    break;
                case Requisito.ORIGEM_CLIENTE:
                    jrbOrigemCliente.setSelected(true);
                    break;
            }

            switch (requisito.getRisco()) {
                case Requisito.RISCO_ALTO:
                    jrbRiscoAlto.setSelected(true);
                    break;
                case Requisito.RISCO_BAIXO:
                    jrbRiscoBaixo.setSelected(true);
                    break;
            }

            switch (requisito.getPrioridade()) {
                case Requisito.PRIORIDADE_ALTA:
                    jrbPrioridadeAlta.setSelected(true);
                    break;
                case Requisito.PRIORIDADE_MEDIA:
                    jrbPrioridadeMedia.setSelected(true);
                    break;
                case Requisito.PRIORIDADE_BAIXA:
                    jrbPrioridadeBaixa.setSelected(true);
                    break;
            }

            modelCasosAssociados.clear();
            modelCasosExistentes.clear();
            modelTestesAssociados.clear();
            modelTestesExistentes.clear();

            for (CasoUso c : requisito.getProjecto().getListaCasosUsoValidos()) {
                if (requisito.getCasosUso().contains(c)) {
                    modelCasosAssociados.addElement(c);
                } else {
                    modelCasosExistentes.addElement(c);
                }

            }

            for (Teste t : requisito.getProjecto().getListaTestesValidos()) {
                if (requisito.getTestes().contains(t)) {
                    modelTestesAssociados.addElement(t);
                } else {
                    modelTestesExistentes.addElement(t);
                }

            }
        }
    }//GEN-LAST:event_jlstRequisitosValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup btgOrigem;
    private javax.swing.ButtonGroup btgPrioridade;
    private javax.swing.ButtonGroup btgRisco;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton jbtnAdicionarAssociacaoCasoUso;
    private javax.swing.JButton jbtnAdicionarAssociacaoTeste;
    private javax.swing.JButton jbtnAdicionarTodasAssociacoesCasoUso;
    private javax.swing.JButton jbtnAdicionarTodasAssociacoesTeste;
    private javax.swing.JButton jbtnFechar;
    private javax.swing.JButton jbtnRemoverAssociacaoCasoUso;
    private javax.swing.JButton jbtnRemoverAssociacaoTeste;
    private javax.swing.JButton jbtnRemoverTodasAssociacoesCasoUso;
    private javax.swing.JButton jbtnRemoverTodasAssociacoesTeste;
    private javax.swing.JList jlstCasosAssociados;
    private javax.swing.JList jlstCasosExistentes;
    private javax.swing.JList jlstRequisitos;
    private javax.swing.JList jlstTestesAssociados;
    private javax.swing.JList jlstTestesExistentes;
    private javax.swing.JPanel jpCaracteristicasRequisito;
    private javax.swing.JPanel jpCasosUso;
    private javax.swing.JPanel jpRequisitos;
    private javax.swing.JPanel jpTestes;
    private javax.swing.JRadioButton jrbOrigemCliente;
    private javax.swing.JRadioButton jrbOrigemEquipa;
    private javax.swing.JRadioButton jrbPrioridadeAlta;
    private javax.swing.JRadioButton jrbPrioridadeBaixa;
    private javax.swing.JRadioButton jrbPrioridadeMedia;
    private javax.swing.JRadioButton jrbRiscoAlto;
    private javax.swing.JRadioButton jrbRiscoBaixo;
    private javax.swing.JTextArea jtaDescricao;
    private javax.swing.JTextField jtfIdentificador;
    // End of variables declaration//GEN-END:variables
}
