/*
 * PainelGestaoRequisitos.java
 *
 * Created on 8 de Novembro de 2007, 11:57
 */

package requirementsmanager.gui;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import requirementsmanager.model.CasoUso;
import requirementsmanager.model.PontoExtensao;
import requirementsmanager.model.Requisito;
import requirementsmanager.model.Sistema;

/**
 *
 * @author  ei10608
 */
public class PainelGestaoCasosUso extends javax.swing.JPanel {
    private CasoUso caso;
    private Sistema sist;
    private DefaultListModel modelAssociados, modelExistentes;
    private boolean byUser = false;
    
    /** Creates new form PainelGestaoRequisitos */
    public PainelGestaoCasosUso(Sistema sist) {
        this.sist = sist;
        initComponents();
        byUser = true;        
    }
    
    private void valueChanged() {
        if (byUser) {
            caso.setIdentificador(txtId.getText().trim());
            caso.setDescricao(txtDescricao.getText().trim());
        }
    }
    
    public void mostarCasoUso(CasoUso caso){
        byUser = false;
        this.caso = caso;
        
        txtId.setText(caso.getIdentificador());
        txtDescricao.setText(caso.getDescricao());
        cmbPontos.removeAllItems();
        for(PontoExtensao p : caso.getPontosExtensaoValidos())
            cmbPontos.addItem(p);

        ((JTextField)cmbPontos.getEditor().getEditorComponent()).getDocument().addDocumentListener(new AlteracaoComboBoxListener());
        
        modelAssociados = new DefaultListModel();
        modelExistentes = new DefaultListModel();
        listAssociados.setModel(modelAssociados);
        listExistentes.setModel(modelExistentes);

        for(Requisito r : caso.getProjecto().getListaRequisitosValidos()){
            if(caso.getRequisitos().contains(r))
                modelAssociados.addElement(r);
            else
                modelExistentes.addElement(r);
        }
        byUser = true;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtDescricao = new javax.swing.JTextArea();
        txtDescricao.getDocument().addDocumentListener(new PainelGestaoCasosUso.AlteracaoDocumentoListener());
        txtId = new javax.swing.JTextField();
        txtId.getDocument().addDocumentListener(new PainelGestaoCasosUso.AlteracaoDocumentoListener());
        jLabel3 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        cmbPontos = new javax.swing.JComboBox();
        btnAddPonto = new javax.swing.JButton();
        btnRemovePonto = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        listExistentes = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        btnDesassociar = new javax.swing.JButton();
        btnAssociar = new javax.swing.JButton();
        btnDesassociarTodos = new javax.swing.JButton();
        btnAssociarTodos = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        listAssociados = new javax.swing.JList();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(" Características do Caso de Uso "));

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        jLabel1.setText(bundle.getString("Identificador:")); // NOI18N

        jLabel2.setText("Descrição:");

        txtDescricao.setColumns(20);
        txtDescricao.setRows(5);
        jScrollPane1.setViewportView(txtDescricao);

        jLabel3.setText("Pontos de Extensão:");

        cmbPontos.setEditable(true);

        btnAddPonto.setIcon(new javax.swing.ImageIcon(getClass().getResource("/requirementsmanager/resources/images/x16/edit_add.png"))); // NOI18N
        btnAddPonto.setFocusCycleRoot(true);
        btnAddPonto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddPontoActionPerformed(evt);
            }
        });

        btnRemovePonto.setIcon(new javax.swing.ImageIcon(getClass().getResource("/requirementsmanager/resources/images/x16/edit_remove.png"))); // NOI18N
        btnRemovePonto.setFocusCycleRoot(true);
        btnRemovePonto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemovePontoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 448, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 379, Short.MAX_VALUE)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cmbPontos, 0, 276, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAddPonto, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRemovePonto, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(cmbPontos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(btnRemovePonto, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(btnAddPonto, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(" Requisitos "));

        jScrollPane2.setViewportView(listExistentes);

        jLabel6.setText(bundle.getString("Existentes")); // NOI18N

        jLabel7.setText(bundle.getString("Associados")); // NOI18N

        btnDesassociar.setText(bundle.getString("<")); // NOI18N
        btnDesassociar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarActionPerformed(evt);
            }
        });

        btnAssociar.setText(bundle.getString(">")); // NOI18N
        btnAssociar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarActionPerformed(evt);
            }
        });

        btnDesassociarTodos.setText(bundle.getString("<<")); // NOI18N
        btnDesassociarTodos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarTodosActionPerformed(evt);
            }
        });

        btnAssociarTodos.setText(bundle.getString(">>")); // NOI18N
        btnAssociarTodos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarTodosActionPerformed(evt);
            }
        });

        jScrollPane3.setViewportView(listAssociados);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 193, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(btnAssociarTodos, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnAssociar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociarTodos)))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
                    .addComponent(jLabel7))
                .addContainerGap())
        );

        jPanel3Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnAssociar, btnAssociarTodos, btnDesassociar, btnDesassociarTodos});

        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(btnDesassociarTodos)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnDesassociar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociarTodos)))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnAssociarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarActionPerformed
        Requisito r;
        if((r = (Requisito)listExistentes.getSelectedValue()) != null){
            if(sist.associar(caso, r)){
                modelAssociados.addElement(r);
                modelExistentes.removeElement(r);
            }
        }
}//GEN-LAST:event_btnAssociarActionPerformed

    private void btnDesassociarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarActionPerformed
        Requisito r;
        if((r = (Requisito)listAssociados.getSelectedValue()) != null){
            if(sist.desassociar(caso, r)){
                modelExistentes.addElement(r);
                modelAssociados.removeElement(r);
            }
        }
    }//GEN-LAST:event_btnDesassociarActionPerformed

    private void btnAssociarTodosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarTodosActionPerformed
        if(sist.associarTodos(caso)){
            for(int i = 0; i<modelExistentes.size(); i++)
                modelAssociados.addElement(modelExistentes.getElementAt(i));
                modelExistentes.clear();
        }
    }//GEN-LAST:event_btnAssociarTodosActionPerformed

    private void btnDesassociarTodosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarTodosActionPerformed
        if(sist.desassociarTodos(caso)){
            for(int i = 0; i<modelAssociados.size(); i++)
                modelExistentes.addElement(modelAssociados.getElementAt(i));
            modelAssociados.clear();
        }
    }//GEN-LAST:event_btnDesassociarTodosActionPerformed

    private void btnAddPontoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddPontoActionPerformed
        PontoExtensao p;
        cmbPontos.addItem(p = new PontoExtensao(-1, java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language").getString("Novo_Ponto_de_Extensão"), caso));
        cmbPontos.setSelectedItem(p);
        cmbPontos.requestFocus();
        caso.adicionarPontoExtensao(p);
}//GEN-LAST:event_btnAddPontoActionPerformed

    private void btnRemovePontoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemovePontoActionPerformed
        PontoExtensao p = (PontoExtensao)cmbPontos.getSelectedItem();
        
        if(p != null){
            cmbPontos.removeItem(p);
            p.marcarRemocao();
        }
}//GEN-LAST:event_btnRemovePontoActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddPonto;
    private javax.swing.JButton btnAssociar;
    private javax.swing.JButton btnAssociarTodos;
    private javax.swing.JButton btnDesassociar;
    private javax.swing.JButton btnDesassociarTodos;
    private javax.swing.JButton btnRemovePonto;
    private javax.swing.JComboBox cmbPontos;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JList listAssociados;
    private javax.swing.JList listExistentes;
    private javax.swing.JTextArea txtDescricao;
    private javax.swing.JTextField txtId;
    // End of variables declaration//GEN-END:variables

    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }    

    private class AlteracaoComboBoxListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            try {
                Document doc = e.getDocument();
                String txt = doc.getText(0, doc.getLength());
                ((PontoExtensao)cmbPontos.getSelectedItem()).setNome(txt);
            } catch (BadLocationException ex) {
                Logger.getLogger(PainelGestaoCasosUso.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        public void removeUpdate(DocumentEvent e) {

        }

        public void changedUpdate(DocumentEvent e) {

        }
    }

}
