/*
 * PainelGestaoRequisitos.java
 *
 * Created on 8 de Novembro de 2007, 11:57
 */

package requirementsmanager.gui;

import javax.swing.DefaultListModel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import requirementsmanager.model.CasoUso;
import requirementsmanager.model.Requisito;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Teste;

/**
 *
 * @author  ei10608
 */
public class PainelGestaoRequisitos extends javax.swing.JPanel {
    private Requisito requisito;
    private Sistema sist;
    private DefaultListModel modelAssociadosC, modelExistentesC, modelAssociadosT, modelExistentesT;
    private boolean byUser = true;
    
    /** Creates new form PainelGestaoRequisitos */
    public PainelGestaoRequisitos(Sistema sist) {
        this.sist = sist;
        initComponents();
    }
    
    private void valueChanged() {
        if(byUser) {
            requisito.setIdentificador(txtIdentificador.getText().trim());
            requisito.setDescricao(txtDescricao.getText().trim());
        }
    }

    public void mostrarRequisito(Requisito requisito) {
        this.requisito = requisito;
        byUser = false;
        
        txtIdentificador.setText(requisito.getIdentificador());
        txtDescricao.setText(requisito.getDescricao());
        switch(requisito.getOrigem()){
            case Requisito.ORIGEM_EQUIPA:
                    grpOrigem.setSelected(btnEquipa.getModel(), true);
                break;
            case Requisito.ORIGEM_CLIENTE:
                    grpOrigem.setSelected(btnCliente.getModel(), true);
                break;
        }
        switch(requisito.getRisco()){
            case Requisito.RISCO_ALTO:
                    grpRisco.setSelected(btnAlto.getModel(), true);
                break;
            case Requisito.RISCO_BAIXO:
                    grpRisco.setSelected(btnBaixo.getModel(), true);
                break;
        }
        switch(requisito.getPrioridade()){
            case Requisito.PRIORIDADE_ALTA:
                    grpPrioridade.setSelected(btnAlta.getModel(), true);
                break;
            case Requisito.PRIORIDADE_MEDIA:
                    grpPrioridade.setSelected(btnMedia.getModel(), true);
                break;
            case Requisito.PRIORIDADE_BAIXA:
                    grpPrioridade.setSelected(btnBaixa.getModel(), true);
                break;
        }
        
        modelAssociadosC = new DefaultListModel();
        modelExistentesC = new DefaultListModel();
        modelAssociadosT = new DefaultListModel();
        modelExistentesT = new DefaultListModel();
        listAssociadosC.setModel(modelAssociadosC);
        listExistentesC.setModel(modelExistentesC);
        listAssociadosT.setModel(modelAssociadosT);
        listExistentesT.setModel(modelExistentesT);
        
        for(CasoUso c : requisito.getProjecto().getListaCasosUsoValidos()){
            if(requisito.getCasosUso().contains(c))
                modelAssociadosC.addElement(c);
            else
                modelExistentesC.addElement(c);
        }
        
        for(Teste t : requisito.getProjecto().getListaTestesValidos()){
            if(requisito.getTestes().contains(t))
                modelAssociadosT.addElement(t);
            else
                modelExistentesT.addElement(t);
        }
        
        byUser = true;
    }
    
    private void mudarOrigem() {
        if(btnEquipa.isSelected()) {
            requisito.setOrigem(Requisito.ORIGEM_EQUIPA);
        } else {
            requisito.setOrigem(Requisito.ORIGEM_CLIENTE);
        }
    }
    
    private void mudarRisco(){
        if(btnAlto.isSelected()) {
            requisito.setRisco(Requisito.RISCO_ALTO);
        } else {
            requisito.setRisco(Requisito.RISCO_BAIXO);
        }        
    }
    
    private void mudarPrioridade() {
        if(btnAlta.isSelected()) {
            requisito.setPrioridade(Requisito.PRIORIDADE_ALTA);
        } else if(btnMedia.isSelected()) {
            requisito.setPrioridade(Requisito.PRIORIDADE_MEDIA);
        } else {
            requisito.setPrioridade(Requisito.PRIORIDADE_BAIXA);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        grpOrigem = new javax.swing.ButtonGroup();
        grpRisco = new javax.swing.ButtonGroup();
        grpPrioridade = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtDescricao = new javax.swing.JTextArea();
        txtDescricao.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        txtIdentificador = new javax.swing.JTextField();
        txtIdentificador.getDocument().addDocumentListener(new AlteracaoDocumentoListener());
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        btnEquipa = new javax.swing.JRadioButton();
        btnCliente = new javax.swing.JRadioButton();
        btnAlto = new javax.swing.JRadioButton();
        btnBaixo = new javax.swing.JRadioButton();
        btnAlta = new javax.swing.JRadioButton();
        btnMedia = new javax.swing.JRadioButton();
        btnBaixa = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        listExistentesC = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        btnDesassociarC = new javax.swing.JButton();
        btnAssociarC = new javax.swing.JButton();
        btnDesassociarTodosC = new javax.swing.JButton();
        btnAssociarTodosC = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        listAssociadosC = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        listExistentesT = new javax.swing.JList();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        btnDesassociarT = new javax.swing.JButton();
        btnAssociarT = new javax.swing.JButton();
        btnDesassociarTodosT = new javax.swing.JButton();
        btnAssociarTodosT = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        listAssociadosT = new javax.swing.JList();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(" Características do Requisito "));

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        jLabel1.setText(bundle.getString("PGESTAOREQUISITOS_IDENTIFICADOR")); // NOI18N

        jLabel2.setText("Descrição:");

        txtDescricao.setColumns(20);
        txtDescricao.setRows(5);
        jScrollPane1.setViewportView(txtDescricao);

        jLabel3.setText(bundle.getString("PGESTAOREQUISITOS_LBLRISCO")); // NOI18N

        jLabel4.setText(bundle.getString("PGESTAOREQUISITOS_LBLORIGEM")); // NOI18N

        jLabel5.setText(bundle.getString("PGESTAOREQUISITOS_LBLPRIORIDADE")); // NOI18N

        grpOrigem.add(btnEquipa);
        btnEquipa.setText(bundle.getString("PGESTAOREQUISITOS_RDBEQUIPA")); // NOI18N
        btnEquipa.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnEquipa.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnEquipa.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnEquipaMouseClicked(evt);
            }
        });

        grpOrigem.add(btnCliente);
        btnCliente.setText(bundle.getString("PGESTAOREQUISITOS_RDBCLIENTE")); // NOI18N
        btnCliente.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnCliente.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnCliente.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnClienteMouseClicked(evt);
            }
        });

        grpRisco.add(btnAlto);
        btnAlto.setText(bundle.getString("PGESTAOREQUISITOS_RDBALTO")); // NOI18N
        btnAlto.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnAlto.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAlto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAltoMouseClicked(evt);
            }
        });

        grpRisco.add(btnBaixo);
        btnBaixo.setText(bundle.getString("PGESTAOREQUISITOS_RDBBAIXO")); // NOI18N
        btnBaixo.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnBaixo.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnBaixo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnBaixoMouseClicked(evt);
            }
        });

        grpPrioridade.add(btnAlta);
        btnAlta.setText(bundle.getString("PGESTAOREQUISITOS_RDBALTA")); // NOI18N
        btnAlta.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnAlta.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAlta.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAltaMouseClicked(evt);
            }
        });

        grpPrioridade.add(btnMedia);
        btnMedia.setText("Média");
        btnMedia.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnMedia.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnMedia.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnMediaMouseClicked(evt);
            }
        });

        grpPrioridade.add(btnBaixa);
        btnBaixa.setText(bundle.getString("PGESTAOREQUISITOS_RDBBAIXA")); // NOI18N
        btnBaixa.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        btnBaixa.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnBaixa.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnBaixaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 397, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(txtIdentificador, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 207, Short.MAX_VALUE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3)
                            .addComponent(jLabel5))
                        .addGap(17, 17, 17)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnEquipa)
                            .addComponent(btnAlto)
                            .addComponent(btnAlta))
                        .addGap(15, 15, 15)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(btnMedia)
                                .addGap(23, 23, 23)
                                .addComponent(btnBaixa))
                            .addComponent(btnBaixo)
                            .addComponent(btnCliente))
                        .addGap(101, 101, 101)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtIdentificador, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnEquipa)
                    .addComponent(jLabel4)
                    .addComponent(btnCliente))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(btnAlto)
                    .addComponent(btnBaixo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(btnAlta)
                    .addComponent(btnMedia)
                    .addComponent(btnBaixa))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(" Casos de Uso "));

        jScrollPane2.setViewportView(listExistentesC);

        jLabel6.setText(bundle.getString("PGESTAOREQUISITOS_LBLCUEXISTENTES")); // NOI18N

        jLabel7.setText(bundle.getString("PGESTAOREQUISITOS_CUASSOCIADOS")); // NOI18N

        btnDesassociarC.setText(bundle.getString("<")); // NOI18N
        btnDesassociarC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarCActionPerformed(evt);
            }
        });

        btnAssociarC.setText(bundle.getString(">")); // NOI18N
        btnAssociarC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarCActionPerformed(evt);
            }
        });

        btnDesassociarTodosC.setText(bundle.getString("<<")); // NOI18N
        btnDesassociarTodosC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarTodosCActionPerformed(evt);
            }
        });

        btnAssociarTodosC.setText(bundle.getString(">>")); // NOI18N
        btnAssociarTodosC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarTodosCActionPerformed(evt);
            }
        });

        jScrollPane3.setViewportView(listAssociadosC);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(btnAssociarTodosC, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnAssociarC, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociarC, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociarTodosC)))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                    .addComponent(jLabel7))
                .addContainerGap())
        );

        jPanel3Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnAssociarC, btnAssociarTodosC, btnDesassociarC, btnDesassociarTodosC});

        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, 0, 0, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(btnDesassociarTodosC)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnDesassociarC)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociarC)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociarTodosC)))
                .addContainerGap())
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(" Testes "));

        jScrollPane4.setViewportView(listExistentesT);

        jLabel8.setText(bundle.getString("PGESTAOREQUISITOS_TEXISTENTES")); // NOI18N

        jLabel9.setText(bundle.getString("PGESTAOREQUISITOS_TASSOCIADOS")); // NOI18N

        btnDesassociarT.setText(bundle.getString("<")); // NOI18N
        btnDesassociarT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarTActionPerformed(evt);
            }
        });

        btnAssociarT.setText(bundle.getString(">")); // NOI18N
        btnAssociarT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarTActionPerformed(evt);
            }
        });

        btnDesassociarTodosT.setText(bundle.getString("<<")); // NOI18N
        btnDesassociarTodosT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesassociarTodosTActionPerformed(evt);
            }
        });

        btnAssociarTodosT.setText(bundle.getString(">>")); // NOI18N
        btnAssociarTodosT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssociarTodosTActionPerformed(evt);
            }
        });

        jScrollPane5.setViewportView(listAssociadosT);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(btnAssociarTodosT, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnAssociarT, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociarT, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnDesassociarTodosT)))
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                    .addComponent(jLabel9))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jLabel9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane5, 0, 0, Short.MAX_VALUE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(btnDesassociarTodosT)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnDesassociarT)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociarT)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAssociarTodosT)))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnDesassociarTodosCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarTodosCActionPerformed
        if(sist.desassociarTodosCasosUso(requisito)){
            for(int i = 0; i<modelAssociadosC.size(); i++)
                modelExistentesC.addElement(modelAssociadosC.getElementAt(i));
            modelAssociadosC.clear();
        }
    }//GEN-LAST:event_btnDesassociarTodosCActionPerformed

    private void btnDesassociarCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarCActionPerformed
        CasoUso c;
        if((c = (CasoUso)listAssociadosC.getSelectedValue()) != null){
            if(sist.desassociar(c, requisito)){
                modelExistentesC.addElement(c);
                modelAssociadosC.removeElement(c);
            }
        }
    }//GEN-LAST:event_btnDesassociarCActionPerformed

    private void btnAssociarCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarCActionPerformed
        CasoUso c;
        if((c = (CasoUso)listExistentesC.getSelectedValue()) != null){
            if(sist.associar(c, requisito)){
                modelAssociadosC.addElement(c);
                modelExistentesC.removeElement(c);
            }
        }
    }//GEN-LAST:event_btnAssociarCActionPerformed

    private void btnAssociarTodosCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarTodosCActionPerformed
        if(sist.associarTodosCasosUso(requisito)){
            for(int i = 0; i<modelExistentesC.size(); i++)
                modelAssociadosC.addElement(modelExistentesC.getElementAt(i));
            modelExistentesC.clear();
        }
    }//GEN-LAST:event_btnAssociarTodosCActionPerformed

    private void btnDesassociarTodosTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarTodosTActionPerformed
        if(sist.desassociarTodosTestes(requisito)){
            for(int i = 0; i<modelAssociadosT.size(); i++)
                modelExistentesT.addElement(modelAssociadosT.getElementAt(i));
            modelAssociadosT.clear();
        }
    }//GEN-LAST:event_btnDesassociarTodosTActionPerformed

    private void btnDesassociarTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesassociarTActionPerformed
        Teste t;
        if((t = (Teste)listAssociadosT.getSelectedValue()) != null){
            if(sist.desassociar(t, requisito)){
                modelExistentesT.addElement(t);
                modelAssociadosT.removeElement(t);
            }
        }
    }//GEN-LAST:event_btnDesassociarTActionPerformed

    private void btnAssociarTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarTActionPerformed
        Teste t;
        if((t = (Teste)listExistentesT.getSelectedValue()) != null){
            if(sist.associar(t, requisito)){
                modelAssociadosT.addElement(t);
                modelExistentesT.removeElement(t);
            }
        }
    }//GEN-LAST:event_btnAssociarTActionPerformed

    private void btnAssociarTodosTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssociarTodosTActionPerformed
        if(sist.associarTodosTestes(requisito)){
            for(int i = 0; i<modelExistentesT.size(); i++)
                modelAssociadosT.addElement(modelExistentesT.getElementAt(i));
            modelExistentesT.clear();
        }
    }//GEN-LAST:event_btnAssociarTodosTActionPerformed

    private void btnEquipaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnEquipaMouseClicked
        mudarOrigem();
    }//GEN-LAST:event_btnEquipaMouseClicked

    private void btnClienteMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnClienteMouseClicked
        mudarOrigem();
    }//GEN-LAST:event_btnClienteMouseClicked

    private void btnAltoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAltoMouseClicked
        mudarRisco();
    }//GEN-LAST:event_btnAltoMouseClicked

    private void btnBaixoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnBaixoMouseClicked
        mudarRisco();
    }//GEN-LAST:event_btnBaixoMouseClicked

    private void btnAltaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAltaMouseClicked
        mudarPrioridade();
    }//GEN-LAST:event_btnAltaMouseClicked

    private void btnMediaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnMediaMouseClicked
        mudarPrioridade();
    }//GEN-LAST:event_btnMediaMouseClicked

    private void btnBaixaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnBaixaMouseClicked
        mudarPrioridade();
    }//GEN-LAST:event_btnBaixaMouseClicked
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton btnAlta;
    private javax.swing.JRadioButton btnAlto;
    private javax.swing.JButton btnAssociarC;
    private javax.swing.JButton btnAssociarT;
    private javax.swing.JButton btnAssociarTodosC;
    private javax.swing.JButton btnAssociarTodosT;
    private javax.swing.JRadioButton btnBaixa;
    private javax.swing.JRadioButton btnBaixo;
    private javax.swing.JRadioButton btnCliente;
    private javax.swing.JButton btnDesassociarC;
    private javax.swing.JButton btnDesassociarT;
    private javax.swing.JButton btnDesassociarTodosC;
    private javax.swing.JButton btnDesassociarTodosT;
    private javax.swing.JRadioButton btnEquipa;
    private javax.swing.JRadioButton btnMedia;
    private javax.swing.ButtonGroup grpOrigem;
    private javax.swing.ButtonGroup grpPrioridade;
    private javax.swing.ButtonGroup grpRisco;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JList listAssociadosC;
    private javax.swing.JList listAssociadosT;
    private javax.swing.JList listExistentesC;
    private javax.swing.JList listExistentesT;
    private javax.swing.JTextArea txtDescricao;
    private javax.swing.JTextField txtIdentificador;
    // End of variables declaration//GEN-END:variables

    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }    
}
