/*
 * PainelGestaoTestesAssociados.java
 *
 * Created on 15 de Novembro de 2007, 11:54
 */

package requirementsmanager.gui;

import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import requirementsmanager.model.Sistema;
import requirementsmanager.model.Teste;
import requirementsmanager.model.TipoTeste;

/**
 *
 * @author  ei10608
 */
public class PainelGestaoTestesAssociados extends javax.swing.JPanel {
    private Sistema sist;
    private Teste teste;
    private boolean byUser = true;
    
    /** Creates new form PainelGestaoTestesAssociados */
    public PainelGestaoTestesAssociados(Sistema sist) {
        this.sist = sist;
        initComponents();
    }
    
    private void valueChanged() {
        if(byUser) {
            teste.setNome(txtNome.getText().trim());
        }
    }

    public void mostarTeste(Teste teste) {
        this.teste = teste;
        
        byUser = false;
        cmbTipo.removeAllItems();
        for(TipoTeste t : sist.getTiposTeste()){
            cmbTipo.addItem(t);
            if(t.getId() == teste.getTipo().getId())
                cmbTipo.setSelectedItem(t);
        }
        
        txtNome.setText(teste.getNome());
        txtDescricao.setEditable(false);
        txtDescricao.setText(teste.getTipo().getDescricao());
        chkRealizado.setSelected(teste.isRealizado());
        byUser = true;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        cmbTipo = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtDescricao = new javax.swing.JTextArea();
        chkRealizado = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtNome = new javax.swing.JTextField();
        txtNome.getDocument().addDocumentListener(new PainelGestaoTestesAssociados.AlteracaoDocumentoListener());

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("requirementsmanager/resources/languages/language"); // NOI18N
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle.getString("PGESTAOTESTESASS_TITULO"))); // NOI18N

        jLabel1.setText(bundle.getString("PGESTAOTESTESASS_TIPOTESTE")); // NOI18N

        cmbTipo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbTipoActionPerformed(evt);
            }
        });

        jLabel2.setText("Descrição:");

        txtDescricao.setColumns(20);
        txtDescricao.setEditable(false);
        txtDescricao.setRows(5);
        jScrollPane1.setViewportView(txtDescricao);

        chkRealizado.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        chkRealizado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkRealizadoActionPerformed(evt);
            }
        });

        jLabel3.setText(bundle.getString("PGESTAOTESTESASS_REALIZADO")); // NOI18N

        jLabel4.setText(bundle.getString("PGESTAOTESTESASS_NOMETESTE")); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 362, Short.MAX_VALUE)
                    .addComponent(chkRealizado, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtNome, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 362, Short.MAX_VALUE)
                    .addComponent(cmbTipo, 0, 362, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cmbTipo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(chkRealizado))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void chkRealizadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkRealizadoActionPerformed
        teste.setRealizado(chkRealizado.isSelected());
}//GEN-LAST:event_chkRealizadoActionPerformed

    private void cmbTipoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbTipoActionPerformed
        teste.setTipo((TipoTeste)cmbTipo.getSelectedItem());
        byUser = false;
        txtDescricao.setText(((TipoTeste)cmbTipo.getSelectedItem()).getDescricao());
        byUser = true;
    }//GEN-LAST:event_cmbTipoActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox chkRealizado;
    private javax.swing.JComboBox cmbTipo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea txtDescricao;
    private javax.swing.JTextField txtNome;
    // End of variables declaration//GEN-END:variables

    private class AlteracaoDocumentoListener implements DocumentListener {

        public void insertUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void removeUpdate(DocumentEvent e) {
            valueChanged();
        }

        public void changedUpdate(DocumentEvent e) {
        //do nothing
        }
    }    
}
