/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package requirementsmanager.model;

import requirementsmanager.model.listeners.GravavelListener;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import requirementsmanager.utils.Ligacao;

/**
 *
 * @author Knitter
 */
public class Associado implements Gravavel {
    
    private CasoUso casoUso;
    private Requisito requisito;
    private boolean removido;
    private boolean novo;

    public Associado(CasoUso casoUso, Requisito requisito, boolean novo) {
        if(casoUso == null || requisito == null) {
            throw new IllegalArgumentException("caso de uso ou requisito inválido");
        }
        this.casoUso = casoUso;
        this.requisito = requisito;       
        this.novo = novo;
    }
    
    public Associado(CasoUso casoUso, Requisito requisito){
        this(casoUso, requisito, true);
    }
            
    public CasoUso getCasoUso() {
        return casoUso;
    }

    public void setCasoUso(CasoUso casoUso) {
        this.casoUso = casoUso;
    }

    public Requisito getRequisito() {
        return requisito;
    }

    public void setRequisito(Requisito requisito) {
        this.requisito = requisito;
    }

    public boolean gravar() {
        Statement stm;
        boolean sucesso = false;

        if(novo && removido) {
            return true;
        }
        try {
            if (novo) {
                stm = Ligacao.getConnection().createStatement();
                String insert = "INSERT INTO Associado(idCasoUso, idRequisito) VALUES(" + casoUso.getId() + ", " + requisito.getId() + ")";
                
                sucesso = stm.executeUpdate(insert) == 1;

                if (sucesso) {
                    novo = false;
                }

            } else if (removido) {
                stm = Ligacao.getConnection().createStatement();
                String delete = "DELETE FROM Associado WHERE idCasoUso = " + casoUso.getId() + " AND idRequisito = " + requisito.getId();
                
                sucesso = stm.executeUpdate(delete) == 1;
                
                if(sucesso) {
                    removido = false;
                }
            } 
        } catch (SQLException ex) {
            Logger.getLogger(Utilizador.class.getName()).log(Level.SEVERE, null, ex);
        }
        return sucesso;
    }

    public void marcarRemocao() {
        removido = true;
    }

    public boolean isNew() {
        return novo;
    }

    public boolean isRemoved() {
        return removido;
    }
    
    @Override
    public String toString() {
        return "Caso de Uso " + casoUso + " <-> Requisito " + requisito;
    }

    public void fireDataChanged() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void addListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void removeListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
