/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package requirementsmanager.model;

import requirementsmanager.model.listeners.GravavelListener;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import requirementsmanager.utils.Ligacao;

/**
 *
 * @author Knitter
 */
public class Gerir implements Gravavel {

    private Projecto projecto;
    private Gestor gestor;
    private boolean novo;
    private boolean removido;

    public Gerir(Projecto projecto, Gestor gestor, boolean novo) {
        if (projecto == null || gestor == null) {
            throw new IllegalArgumentException("Projecto ou gestor inválido");
        }
        this.projecto = projecto;
        this.gestor = gestor;
        this.novo = novo;
        Logger.getLogger(Gerir.class.getName()).log(Level.INFO, "[GERIR] - [GESTOR]: " + gestor.getId()+ " <> [PROJECTO]: " + projecto.getId() + " - Criar");
    }

    public Gerir(Projecto projecto, Gestor gestor) {
        this(projecto, gestor, true);
    }

    public Gestor getGestor() {
        return gestor;
    }

    public void setGestor(Gestor gestor) {
        this.gestor = gestor;
    }

    public Projecto getProjecto() {
        return projecto;
    }

    public void setProjecto(Projecto projecto) {
        this.projecto = projecto;
    }

    public boolean gravar() {
        Statement stm;
        boolean sucesso = false;

        if(novo && removido) {
            return true;
        }
        try {
            if (novo) {
                stm = Ligacao.getConnection().createStatement();
                String insert = "INSERT INTO Gerir(idGestor, idProjecto) VALUES(" + gestor.getId() + ", " + projecto.getId() + ")";

                sucesso = stm.executeUpdate(insert) == 1;

                if (sucesso) {
                    novo = false;
                    Logger.getLogger(Gerir.class.getName()).log(Level.INFO, "[GERIR] - [GESTOR]: " + gestor.getId()+ " <> [PROJECTO]: " + projecto.getId() + " - Inserido");
                }

            } else if (removido) {
                stm = Ligacao.getConnection().createStatement();
                String delete = "DELETE FROM Gerir WHERE idGestor = " + gestor.getId() + " AND idProjecto = " + projecto.getId();

                sucesso = stm.executeUpdate(delete) == 1;

                if (sucesso) {
                    removido = false;
                    Logger.getLogger(Gerir.class.getName()).log(Level.INFO, "[GERIR] - [GESTOR]: " + gestor.getId()+ " <> [PROJECTO]: " + projecto.getId() + " - Removido");
                }
            }
        } catch (SQLException ex) {
            Logger.getLogger(Utilizador.class.getName()).log(Level.SEVERE, null, ex);
        }
        return sucesso;
    }

    public void marcarRemocao() {
        removido = true;
    }

    public boolean isNew() {
        return novo;
    }

    public boolean isRemoved() {
        return removido;
    }
    
    @Override
    public String toString() {
        return "Gestor " + gestor + " <-> Projecto " + projecto;
    }

    public void fireDataChanged() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void addListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void removeListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
