/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package requirementsmanager.model;

import requirementsmanager.model.listeners.GravavelListener;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import requirementsmanager.utils.Ligacao;

/**
 *
 * @author Knitter
 */
public class Satisfazer implements Gravavel {
    
    private Teste teste;
    private Requisito requisito;
    private boolean novo;
    private boolean removido;
   
    public Satisfazer(Teste teste, Requisito requisito, boolean novo) {
        if(teste == null || requisito == null) {
            throw new IllegalArgumentException("teste ou requisito inválido");
        }
        this.requisito = requisito;
        this.teste = teste;
        this.novo = novo;
    }
    
    public Satisfazer(Teste teste, Requisito requisito){
        this(teste, requisito, true);
    }
    
    public Requisito getRequisito() {
        return requisito;
    }

    public void setRequisito(Requisito requisito) {
        this.requisito = requisito;
    }

    public Teste getTeste() {
        return teste;
    }

    public void setTeste(Teste teste) {
        this.teste = teste;
    }    
    
    public boolean gravar() {
        Statement stm;
        boolean sucesso = false;

        if(novo && removido) {
            return true;
        }
        try {
            if (novo) {
                stm = Ligacao.getConnection().createStatement();
                String insert = "INSERT INTO Satisfazer(idTeste, idRequisito) VALUES(" + teste.getId() + ", " + requisito.getId() + ")";
                
                sucesso = stm.executeUpdate(insert) == 1;

                if (sucesso) {
                    novo = false;
                }

            } else if (removido) {
                stm = Ligacao.getConnection().createStatement();
                String delete = "DELETE FROM Satisfazer WHERE idTeste = " + teste.getId() + " AND idRequisito = " + requisito.getId();
                
                sucesso = stm.executeUpdate(delete) == 1;
                
                if(sucesso) {
                    removido = false;
                }
            } 
        } catch (SQLException ex) {
            Logger.getLogger(Utilizador.class.getName()).log(Level.SEVERE, null, ex);
        }
        return sucesso;
    }

    public void marcarRemocao() {
        removido = true;
    }
    
    @Override
    public String toString() {
        return "Requisito " + requisito + " <-> Teste " + teste; 
    }

    public boolean isNew() {
        return novo;
    }

    public boolean isRemoved() {
        return removido;
    }

    public void fireDataChanged() {
        throw new UnsupportedOperationException("Not supported yet.");
    }


    public void addListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void removeListener(GravavelListener g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
